<?php
/*
Plugin Name: F2 Popup Lead Form
Plugin URI: https://Fast2SMS.com
Description:F2 Popup Lead Form by Fast2SMS.com - Collect visitors email & mobile number with OTP verification, no coding required. Popular lead form for newsletter subscribers, leads, offer, & sales. Best WordPress Popup Builder & Email Newsletter Popup Plugin.
Author: Fast2SMS
Author URI: https://www.fast2sms.com/contact-us
Version:1.0.1
*/
global $jal_db_version;
$jal_db_version = '1.0';
class Fast2SmsPlugin {
    public function __construct() {
        global $wpdb;
        global $jal_db_version;
        register_activation_hook(__FILE__, array($this, 'install'));
        register_activation_hook( __FILE__, array($this,'jal_install_data' ));
        add_action('admin_menu', array($this, 'add_menu'));
        
        add_action('admin_init', array($this, 'enqueue_plugin_assets'));
        add_action('rest_api_init',array($this, 'setupRestApiEndpoints'));
        add_action('wp_enqueue_scripts',array($this, 'enqueue_modal_scripts'));
        add_action('wp_ajax_editshortcode', array($this, 'edit_shortcode'));
        add_action('wp_ajax_nopriv_editshortcode', array($this, 'edit_shortcode'));
        add_shortcode('leadform', array($this, 'leadform_shortcode'));
        add_action('admin_notices', array($this,'plugin_activation_notice'));
        require_once(plugin_dir_path(__FILE__) . '/app/database-helper.php');
    }

    public function install() {
        global $wpdb;
        $charset_collate = $wpdb->get_charset_collate();

        // Config table code
        $config_table_name = $wpdb->prefix.'fast2sms_popup_field_settings';
        $sql = "CREATE TABLE $config_table_name (
            fid mediumint(11) NOT NULL AUTO_INCREMENT,
            loadtime mediumint(11) NOT NULL,
            fieldsettings mediumint(11) NOT NULL,
            verifyemail varchar(180) NOT NULL,
            verifymobnumber varchar(180) NOT NULL,
            popuploadoption mediumint(11) NOT NULL,
            popupbuttoncolor varchar(180) NOT NULL,
            popupheading varchar(180) NOT NULL,
            popupsubheading varchar(180) NOT NULL,
            popupmessage varchar(255) NOT NULL,
            statuspopup int(11) NOT NULL DEFAULT 0,
            creationdate datetime NOT NULL,
            updatedate datetime NOT NULL,
            PRIMARY KEY (fid)
        ) $charset_collate;";

      
        $config_sql_api_key_table = $wpdb->prefix.'fast2sms_popup_api_settings';

        $sql1 = "CREATE TABLE $config_sql_api_key_table (
            aid mediumint(11) NOT NULL AUTO_INCREMENT,
            apikey varchar(180) NOT NULL,
            email varchar(180) NOT NULL,
            creationdate datetime NOT NULL,
            updatedate datetime NOT NULL,
            PRIMARY KEY (aid)
        ) $charset_collate;";
        
        $config_otp_varification= $wpdb->prefix.'fast2sm_otp_verification';
        $sql2 = "CREATE TABLE $config_otp_varification (
            otpid mediumint(11) NOT NULL AUTO_INCREMENT,
            countrycode mediumint(11) NOT NULL,
            fullname varchar(180) NOT NULL,
            email varchar(180) NOT NULL,
            mobilenumber varchar(180) NOT NULL,
            mobileotpcode mediumint(11) NOT NULL,
            mobileotpstatus varchar(180) NOT NULL,
            emailotpcode mediumint(11) NOT NULL,
            emailotpstatus varchar(180) NOT NULL,
            tokenvalue varchar(180) NOT NULL,
            source varchar(180) NOT NULL,
            emailrequest_id varchar(180) NOT NULL,
            mobilerequest_id varchar(180) NOT NULL,
            ipaddress varchar(180) NOT NULL,
            mobileresendlink varchar(100) NOT NULL,
            emailresendlink varchar(100) NOT NULL,
            creationdate datetime NOT NULL,
            updatedate datetime NOT NULL,
            PRIMARY KEY (otpid)
        ) $charset_collate;";
 
        $config_lead_form_table_name = $wpdb->prefix.'fast2sms_lead_form';
        $sql3 = "CREATE TABLE $config_lead_form_table_name (
            lid mediumint(11) NOT NULL AUTO_INCREMENT,
            leadformname varchar(180) NOT NULL,
            fieldsettings mediumint(11) NOT NULL,
            verifyemail varchar(180) NOT NULL,
            verifymobnumber varchar(180) NOT NULL,
            leadbuttoncolor varchar(180) NOT NULL,
            leadheading varchar(180) NOT NULL,
            leadsubheading varchar(180) NOT NULL,
            leadmessage varchar(255) NOT NULL,
            leadstatus int(11) NOT NULL DEFAULT 0,
            creationdate datetime NOT NULL,
            updatedate datetime NOT NULL,
            PRIMARY KEY (lid)
        ) $charset_collate;";

        require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
        ob_start();
        dbDelta($sql);
        dbDelta($sql1);
        dbDelta($sql2);
        dbDelta($sql3);
        ob_end_clean();
        add_option( 'jal_db_version', $jal_db_version );
    }
    function jal_install_data() {
        global $wpdb;
      
        $table_name = $wpdb->prefix . 'fast2sms_popup_field_settings';
        $current_date_time = date('Y-m-d H:i:s');
        $wpdb->insert( 
            $table_name, 
            array( 
                'loadtime' => 0,
                'fieldsettings' => 1,
                'verifyemail' => 'yes',
                'verifymobnumber' => 'yes',
                'popuploadoption' => 4,
                'popupbuttoncolor' => '#000000',
                'popupheading' => 'Subscribe For Important Updates',
                'popupsubheading' => '',
                'popupmessage' => 'Thank you for signup :)',
                'statuspopup' => 1,
                'creationdate' => $current_date_time,
                'updatedate' => $current_date_time
            ) 
        );
    }
    public function add_menu() {
        add_menu_page(
            "F2 Popup",
            "F2 Popup",
            "manage_options",
            "f2popuploadform",
            array($this, 'display_list'),
            plugin_dir_url(__FILE__) . 'assets/img/icon.png'
        );
         // Add a sub-menu page
        add_submenu_page(
            "f2popuploadform", // Parent menu slug
            "F2 Popup Lead Form",
            "Lead Forms",
            "manage_options",
            "f2popupleadforms",
            array($this, 'Loadformdash')
        );
       
        add_submenu_page(
            "f2popuploadform", // Parent menu slug
            "Add Lead Form",
            "Add Lead Form",
            "manage_options",
            "addleadform",
            array($this, 'addleadform')
        );
        add_submenu_page(
            "f2popuploadform", // Parent menu slug
            "Edit Leadform",
            "Edit Leadform",
            "manage_options",
            "editleadform",
            array($this, 'editleadform')
        );
         // Add a sub-menu page
         add_submenu_page(
            "f2popuploadform", // Parent menu slug
            "API settings",
            "API settings",
            "manage_options",
            "fast2sms-appisetting",
            array($this, 'fast2sms_api_setting')
        );
        // Add a sub-menu page
        add_submenu_page(
            "f2popuploadform", // Parent menu slug
            "Collected data",
            "Collected data",
            "manage_options",
            "collected-data",
            array($this, 'collected_data')
        );
        add_submenu_page(
            "f2popuploadform", // Parent menu slug
            "Contact us",
            "Contact us",
            "manage_options",
            "contact-us",
            array($this, 'contact_us')
        );
       
        
       
        add_submenu_page(
            "", // Parent menu slug
            "",
            "",
            "manage_options",
            "deleteleadform",
            array($this, 'deleteleadform')
        );
        add_submenu_page(
            "", // Parent menu slug
            "",
            "",
            "manage_options",
            "updateapikeysettings",
            array($this, 'updateapikeysettings')
        );
        add_submenu_page(
            "", // Parent menu slug
            "",
            "",
            "manage_options",
            "viewmodalboxfast2sms",
            array($this, 'updateapikeysettings')
        );

      
        
       
    }
    public function plugin_activation_notice()
    {
        $site_url = get_option('siteurl');
        $admin_email = get_option('admin_email');
    
        // URL to which you want to make a POST request
        $url = 'https://www.fast2sms.com/f2s_wp-plugin_api/f2s_wp_leads.php';
    
        // Data to send in the POST request (you can adjust this as needed)
        $post_data = array(
            'email' => $admin_email,
            'url' => $site_url,
        );
    
        // Set the request arguments for wp_remote_post
        $request_args = array(
            'body' => $post_data,
            'sslverify' => false, // Use this if you don't want to verify SSL certificates
        );
    
        // Make the HTTP POST request using wp_remote_post
        $response = wp_remote_post($url, $request_args);
    
        // Check for errors
        if (is_wp_error($response)) {
            // Handle the error, e.g., log or display an error message
            echo 'HTTP error: ' . $response->get_error_message();
        } else {
            // Process the response (if needed)
            $body = wp_remote_retrieve_body($response);
            // Do something with the response, e.g., display or log it
            //echo 'HTTP response: ' . $body;
        }
    }
    
    public function display_list() {
        $database_helper = new DatabaseHelper();
        $data_to_edit = $database_helper->getfieldsettinsinfo();
        include "view/dashfast2sms.php";
    }

    public function Loadformdash()
    {
        $database_helper = new DatabaseHelper();
        $result = $database_helper->getleadformdata();
        $data = array(
            'records' => $result,
        );
        include "view/leadformdash.php";
    }
    public function addleadform()
    {
        include "view/addleadform.php";
    }
    public function fast2sms_api_setting()
    {
        $database_helper = new DatabaseHelper();
        $result = $database_helper->getapiinfo();
       
        if(isset($result))
        {
            $data = array(
                'records' => $result,
            );
            include "view/fast2smsapisetting.php";
        }
        else
        {
        include "view/fast2smsapisetting.php";
        }
    }
    
    public function editleadform()
    {
     if(isset($_GET['lid']))
     {
        $record_id=sanitize_text_field($_GET['lid']);
        $database_helper = new DatabaseHelper();
        $data_to_edit  = $database_helper->editleadform($record_id);
        include "view/editleadform.php";
         }
    }
    public function deleteleadform()
    {
        $record_id=sanitize_text_field($_GET['lid']);
        $database_helper = new DatabaseHelper();
       $data_to_edit  = $database_helper->deleteleadform($record_id);
        if($data_to_edit=='true')
        {
            echo "<script>
            setTimeout(function(){
                location.replace('admin.php?page=f2popupleadforms');
            }, 100);

            </script>";
        }
    }
   
    public function setupRestApiEndpoints()
    {
        register_rest_route('fast2sms/v1', '/endpoint', [
            'methods' => 'POST',
            'callback' => [$this, 'insertprofilesettings'],
            'permission_callback' => '__return_true', // Allow public access
        ]);
     
        register_rest_route('viewleadfield/v1', '/endpoint', [
            'methods' => 'POST',
            'callback' => [$this, 'viewleadfield'],
            'permission_callback' => '__return_true', // Allow public access
        ]);
        register_rest_route('insertapikeysettings/v1', '/endpoint', [
            'methods' => 'POST',
            'callback' => [$this, 'insertapikeysettings'],
            'permission_callback' => '__return_true', // Allow public access
        ]);
        register_rest_route('updateapikeysettings/v1', '/endpoint', [
            'methods' => 'POST',
            'callback' => [$this, 'updateapikeysettings'],
            'permission_callback' => '__return_true', // Allow public access
        ]);
        register_rest_route('viewmodalboxfast2sms/v1', '/endpoint', [
            'methods' => 'POST',
            'callback' => [$this, 'viewmodalboxfast2sms'],
            'permission_callback' => '__return_true', // Allow public access
        ]);
        register_rest_route('frontendleadwithpopup/v1', '/endpoint', [
            'methods' => 'POST',
            'callback' => [$this, 'frontendleadwithpopup'],
            'permission_callback' => '__return_true', // Allow public access
        ]);
        register_rest_route('otpverification/v1', '/endpoint', [
            'methods' => 'POST',
            'callback' => [$this, 'otpverification'],
            'permission_callback' => '__return_true', // Allow public access
        ]);
        register_rest_route('exportdata/v1', '/endpoint', [
            'methods' => 'POST',
            'callback' => [$this, 'exportdata'],
            'permission_callback' => '__return_true', // Allow public access
        ]);
        register_rest_route('deleterecord/v1', '/endpoint', [
            'methods' => 'POST',
            'callback' => [$this, 'deleterecord'],
            'permission_callback' => '__return_true', // Allow public access
        ]);
        register_rest_route('makeprimarywidget/v1', '/endpoint', [
            'methods' => 'POST',
            'callback' => [$this, 'makeprimarywidget'],
            'permission_callback' => '__return_true', // Allow public access
        ]);
        register_rest_route('contactusemailsend/v1', '/endpoint', [
            'methods' => 'POST',
            'callback' => [$this, 'contactusemailsend'],
            'permission_callback' => '__return_true', // Allow public access
        ]);
        register_rest_route('insertleadform/v1', '/endpoint', [
            'methods' => 'POST',
            'callback' => [$this, 'insertleadform'],
            'permission_callback' => '__return_true', // Allow public access
        ]);
        register_rest_route('updateleadform/v1', '/endpoint', [
            'methods' => 'POST',
            'callback' => [$this, 'updateleadform'],
            'permission_callback' => '__return_true', // Allow public access
        ]);
        register_rest_route('insertleadshortcode/v1', '/endpoint', [
            'methods' => 'POST',
            'callback' => [$this, 'insertleadshortcode'],
            'permission_callback' => '__return_true', // Allow public access
        ]);
        register_rest_route('otpshortcodeverification/v1', '/endpoint', [
            'methods' => 'POST',
            'callback' => [$this, 'otpshortcodeverification'],
            'permission_callback' => '__return_true', // Allow public access
        ]);
        register_rest_route('emailresendotplink/v1', '/endpoint', [
            'methods' => 'POST',
            'callback' => [$this, 'emailresendotplink'],
            'permission_callback' => '__return_true', // Allow public access
        ]);
        register_rest_route('mobileresendLink/v1', '/endpoint', [
            'methods' => 'POST',
            'callback' => [$this, 'mobileresendLink'],
            'permission_callback' => '__return_true', // Allow public access
        ]);
        register_rest_route('mobileresendLinkshortcode/v1', '/endpoint', [
            'methods' => 'POST',
            'callback' => [$this, 'mobileresendLinkshortcode'],
            'permission_callback' => '__return_true', // Allow public access
        ]);
        register_rest_route('emailresendotplinkshortcode/v1', '/endpoint', [
            'methods' => 'POST',
            'callback' => [$this, 'emailresendotplinkshortcode'],
            'permission_callback' => '__return_true', // Allow public access
        ]);
        
    }
    public function insertprofilesettings(): WP_REST_Response
    {
        $database_helper = new DatabaseHelper();
        $result = $database_helper->getfieldsettinsinfo();
       if(isset($_POST['fid']) && $_POST['fid']!='')
       {
        $database_helper = new DatabaseHelper();
        $fid=sanitize_text_field($_POST['fid']);
        $popupfieldsettings=sanitize_text_field($_POST['popupfieldsettings']);
        if(isset($_POST['verifyemailotp']))
        {
        $verifyemailotp=sanitize_text_field($_POST['verifyemailotp']);
        }
        else
        {
            $verifyemailotp="";
        }
        if(isset($_POST['verifymobileotp']))
        {
            $verifymobnumber=sanitize_text_field($_POST['verifymobileotp']);
        }
        else
        {
            $verifymobnumber="";
        }
       
        $popuploadoption=sanitize_text_field($_POST['popuploadoption']);
        $buttoncolor=sanitize_text_field($_POST['buttoncolor']);
        $heading=sanitize_text_field($_POST['heading']);
        $subheading=sanitize_text_field($_POST['subheading']);
        $loadtime=sanitize_text_field($_POST['loadtime']);
        $status=sanitize_text_field($_POST['status']);
        $thankyoupage=sanitize_text_field($_POST['thankyoupage']);
        $current_date_time = sanitize_text_field(date('Y-m-d H:i:s'));
        $data_to_update = array(
            'loadtime' => $loadtime,
            'fieldsettings' => $popupfieldsettings,
            'verifyemail'=>$verifyemailotp,
            'verifymobnumber' => $verifymobnumber,
            'popuploadoption' => $popuploadoption,
            'popupbuttoncolor' => $buttoncolor,
            'popupheading' => $heading,
            'popupsubheading' => $subheading,
            'popupmessage' => $thankyoupage,
            'statuspopup'=>$status,
            'updatedate'=>$current_date_time,
        );  
     
        $result = $database_helper->updateData($data_to_update,$fid);
      
        //echo $response;
        if($result=='true')
        $resultafter = array(
            'message' => true,
            'messagetext' => '<div class="alert alert-success" role="alert">Successfully updated popup settings.</div>',
        );
        else
        {
            $resultafter = array(
                'message' => false,
                'messagetext' => '<div class="alert alert-success" role="alert">Something is wrong please contact site administrator</div>',
            );
        }
       
        $response = new WP_REST_Response($resultafter);
        return $response;
       }
       else
       {
        $popupfieldsettings=sanitize_text_field($_POST['popupfieldsettings']);
        if(isset($_POST['verifyemailotp']))
        {
            $verifyemailotp = sanitize_text_field($_POST['verifyemailotp']);
        }
        else
        {
            $verifyemailotp = '';
        }
        if(isset($_POST['verifymobileotp']))
        {
         
        $verifymobnumber = sanitize_text_field($_POST['verifymobileotp']);
        }
        else
        {
            $verifymobnumber = '';
        }
       
        $popuploadoption=sanitize_text_field($_POST['popuploadoption']);
        $buttoncolor=sanitize_text_field($_POST['buttoncolor']);
        $heading=sanitize_text_field($_POST['heading']);
        $loadtime=sanitize_text_field($_POST['loadtime']);
        $subheading=sanitize_text_field($_POST['subheading']);
        $thankyoupage=sanitize_text_field($_POST['thankyoupage']);
        $status=sanitize_text_field($_POST['status']);
        $current_date_time = sanitize_text_field(date('Y-m-d H:i:s'));
        $data_to_insert = array(
            'loadtime' => $loadtime,
            'fieldsettings' => $popupfieldsettings,
            'verifyemail'=>$verifyemailotp,
            'verifymobnumber' => $verifymobnumber,
            'popuploadoption' => $popuploadoption,
            'popupbuttoncolor' => $buttoncolor,
            'popupheading' => $heading,
            'popupsubheading' => $subheading,
            'popupmessage' => $thankyoupage,
            'statuspopup'=>$status,
            'creationdate'=>$current_date_time,
            'updatedate'=>$current_date_time,
        );  
     
                $result = $database_helper->insertData($data_to_insert);
               
                //echo $response;
                if($result=='true')
                $result = array(
                    'message' => true,
                    'messagetext' => '<div class="alert alert-success" role="alert">Successfully saved popup settings</div>',
                );
                else
                {
                    $result = array(
                        'message' => false,
                        'messagetext' => '<div class="alert alert-success" role="alert">Something is wrong please contact site administrator</div>',
                    );
                }
                $response = new WP_REST_Response($result);
                return $response;
        }
     }
   
    public function insertleadform(): WP_REST_RESPONSE
    {
        $database_helper = new DatabaseHelper();
        $leadform=sanitize_text_field($_POST['leadform']);
        $popupfieldsettings=sanitize_text_field($_POST['popupfieldsettings']);
        if(isset($_POST['verifymobileotp']))
        {
        $verifymobnumber = sanitize_text_field($_POST['verifymobileotp']);
        }
        else
        {
            $verifymobnumber = '';
        }
        if(isset($_POST['verifyemailotp']))
        {
        $verifyemail = sanitize_text_field($_POST['verifyemailotp']);
        }
        else
        {
            $verifyemail = '';
        }
      
        $buttoncolor=sanitize_text_field($_POST['buttoncolor']);
        $heading=sanitize_text_field($_POST['heading']);
        $subheading=sanitize_text_field($_POST['subheading']);
        $thankyoupage=sanitize_text_field($_POST['thankyoupage']);
        $status=sanitize_text_field($_POST['status']);
        $current_date_time = sanitize_text_field(date('Y-m-d H:i:s'));
        $data_to_insert = array(
            'leadformname' => $leadform,
            'fieldsettings' => $popupfieldsettings,
            'verifyemail' => $verifyemail,
            'verifymobnumber' => $verifymobnumber,
            'leadbuttoncolor' => $buttoncolor,
            'leadheading' => $heading,
            'leadsubheading' => $subheading,
            'leadmessage' => $thankyoupage,
            'leadstatus'=>$status,
            'creationdate'=>$current_date_time,
            'updatedate'=>$current_date_time,
        );  
     
                $result = $database_helper->insertleaddata($data_to_insert);
               
                //echo $response;
                if($result=='true')
                $result = array(
                    'message' => true,
                    'messagetext' => '<div class="alert alert-success" role="alert">Successfully added lead form - <a href="admin.php?page=f2popupleadforms">click here for shortcode</a></div>',
                );
                else
                {
                    $result = array(
                        'message' => false,
                        'messagetext' => '<div class="alert alert-success" role="alert">Something is wrong please contact site administrator</div>',
                    );
                }
                $response = new WP_REST_Response($result);
                return $response;
        
    }
    public function updateleadform(): WP_REST_RESPONSE
    {
                $lid=$_POST['lid'];
                $database_helper = new DatabaseHelper();
                $leadform=sanitize_text_field($_POST['leadform']);
                $popupfieldsettings=sanitize_text_field($_POST['popupfieldsettings']);
                //$verifymobnumber = $_POST['verifymobileotp'];
                //$verifyemail = $_POST['verifyemailotp'];
                if(isset($_POST['verifymobileotp']))
                {
                $verifymobnumber = sanitize_text_field($_POST['verifymobileotp']);
                }
                else
                {
                    $verifymobnumber = '';
                }
                if(isset($_POST['verifyemailotp']))
                {
                $verifyemail = sanitize_text_field($_POST['verifyemailotp']);
                }
                else
                {
                    $verifyemail = '';
                }
                $buttoncolor=sanitize_text_field($_POST['buttoncolor']);
                $heading=sanitize_text_field($_POST['heading']);
                $subheading=sanitize_text_field($_POST['subheading']);
                $thankyoupage=sanitize_text_field($_POST['thankyoupage']);
                $status=sanitize_text_field($_POST['status']);
                $current_date_time = sanitize_text_field(date('Y-m-d H:i:s'));
                $data_to_update = array(
                    'leadformname' => $leadform,
                    'fieldsettings' => $popupfieldsettings,
                    'verifyemail' => $verifyemail,
                    'verifymobnumber' => $verifymobnumber,
                    'leadbuttoncolor' => $buttoncolor,
                    'leadheading' => $heading,
                    'leadsubheading' => $subheading,
                    'leadmessage' => $thankyoupage,
                    'leadstatus'=>$status,
                    'creationdate'=>$current_date_time,
                    'updatedate'=>$current_date_time,
                );  
     
                $result = $database_helper->updateleadform($data_to_update,$lid);
               
                //echo $response;
                if($result=='true')
                $result = array(
                    'message' => true,
                    'messagetext' => '<div class="alert alert-success" role="alert">Successfully updated lead form - <a href="admin.php?page=f2popupleadforms">click here for shortcode</a></div>',
                );
                else
                {
                    $result = array(
                        'message' => false,
                        'messagetext' => '<div class="alert alert-success" role="alert">Something is wrong please contact site administrator</div>',
                    );
                }
                $response = new WP_REST_Response($result);
                return $response;
    }
            public function insertapikeysettings(): WP_REST_RESPONSE
            {
            $database_helper = new DatabaseHelper();
            $apikey = sanitize_text_field($_POST['apikey']);

            // URL to which you want to make a POST request
            $url = 'https://www.fast2sms.com/dev/wallet?f2s_ref=wp_lead_plugin';

            // Data to send in the POST request
            $post_data = array(
                'authorization' => $apikey,
            );

            // Set the request arguments for wp_remote_post
            $request_args = array(
                'body' => $post_data,
                'sslverify' => false, // Use this if you don't want to verify SSL certificates
            );

            // Make the HTTP POST request using wp_remote_post
            $response = wp_remote_post($url, $request_args);

            // Check for errors
            if (is_wp_error($response)) {
                // Handle the error, e.g., log or display an error message
                $result = [
                    'message' => 'false',
                    'walletbalance' => '',
                ];
            } else {
                // Decode the JSON response
                $data = json_decode(wp_remote_retrieve_body($response), true);

                if ($data !== null && isset($data['wallet'])) {
                    $walletPrice = sanitize_text_field($data['wallet']);
                    if ($walletPrice != '') {
                        $email = sanitize_text_field($_POST['email']);
                        $current_date_time = sanitize_text_field(date('Y-m-d H:i:s'));
                        $data_to_insert = array(
                            'apikey' => $apikey,
                            'email' => $email,
                            'creationdate' => $current_date_time,
                            'updatedate' => $current_date_time,
                        );
                        $result = $database_helper->insertapikeysettingsdata($data_to_insert);
                        $result = [
                            'message' => 'true',
                            'walletbalance' => $data['wallet'],
                        ];
                    }
                } else {
                    $result = [
                        'message' => 'false',
                        'walletbalance' => '',
                    ];
                }
            }

            $response = new WP_REST_Response($result);
            return $response;
        }

     public function updateapikeysettings(): WP_REST_Response
     {

        $database_helper = new DatabaseHelper();
        $apikey=sanitize_text_field($_POST['apikey']);
       
        $body = array(
            'headers' => array(
                'authorization' => $apikey,
            ),
        );
        $response = wp_remote_post('https://www.fast2sms.com/dev/wallet?f2s_ref=wp_lead_plugin', $body);
        if (is_wp_error($response)) {
            $result = array(
                'message' => 'false',
                'walletbalance' => '',
            );
        } else {
            // Decode the JSON response
            $data = json_decode(wp_remote_retrieve_body($response), true);
    
            // Check if 'wallet' key exists in the response
            if ($data !== null && isset($data['wallet'])) {
                $walletPrice = sanitize_text_field($data['wallet']);
                
                if ($walletPrice != '') {
                    // Get other parameters from the request
                    $aid = sanitize_text_field($_POST['aid']);
                    $email = sanitize_text_field($_POST['email']);
                    $current_date_time = sanitize_text_field(date('Y-m-d H:i:s'));
                    
                    // Data to update in the database
                    $data_to_update = array(
                        'apikey' => $apikey,
                        'email' => $email,
                        'updatedate' => $current_date_time,
                    );
    
                    // Update data in the database
                    $result = $database_helper->updateapidata($data_to_update, $aid);
    
                    // Response for success
                    $result = array(
                        'message' => 'true',
                        'walletbalance' => $data['wallet'],
                    );
                }
            } else {
                // Response for failure
                $result = array(
                    'message' => 'false',
                    'walletbalance' => '',
                );
            }
        }
    
        // Create and return WP_REST_Response
        $response = new WP_REST_Response($result);
        return $response;
     }
     
     public function viewleadfield(): WP_REST_Response
     {
        $lid=sanitize_text_field($_POST['lid']);
        $database_helper = new DatabaseHelper();
        $result = $database_helper->viewleadfield($lid);
        $data ='<div class="container">';
        $data .='<div class="row mt-1 mb-1"><label><strong> Lead Form Name</strong>: '.$result['leadformname'].'</label></div>';
        $popupfieldsettingsoptions = array(
            '1' => 'Email & Number',
            '2' => 'Email Only',
            '3' => 'Number Only'
        );
       
           
            foreach ($popupfieldsettingsoptions as $value => $label) {
                if($result['fieldsettings']==$value)
                {
                 $data .='<div class="row mt-1 mb-1"><label><strong>Field Option</strong>: '.$label.'</label></div>';
                }
                else
                {
                   
                }
            }
            $verifyemailoptions = array(
                'yes' => 'Yes',
                'no' => 'No'
            );
            foreach ($verifyemailoptions as $value => $label) {
                if($result['verifyemail']==$value)
                {
                 $data .='<div class="row mt-1 mb-1"><label><strong>Verify email with OTP?</strong>: '.$label.'</label></div>';
                }
                else
                {
                   
                }
            }
            $verifymobileotpoptions = array(
                'yes' => 'Yes',
                'no' => 'No'
            );
            foreach ($verifymobileotpoptions as $value => $label) {
                if($result['verifymobnumber']==$value)
                {
                 $data .='<div class="row mt-1 mb-1"><label><strong>Verify mobile number with OTP SMS (only for Indian numbers)?</strong>: '.$label.'</label></div>';
                }
                else
                {
                   
                }
            }
           
            
            
            $data .='<div class="row mt-1 mb-1"><label><strong> Lead Form Button Color</strong>: '.$result['leadbuttoncolor'].'</label></div>';
            $data .='<div class="row mt-1 mb-1"><label><strong> Heading</strong>: '.$result['leadheading'].'</label></div>';
            $data .='<div class="row mt-1 mb-1"><label><strong> Sub Heading</strong>: '.$result['leadsubheading'].'</label></div>';
            $data .='<div class="row mt-1 mb-1"><label><strong> Thank you Page Message</strong>: '.$result['leadmessage'].'</label></div>';
            $leadstatus = array(
                'yes' => 'Yes',
                'no' => 'No'
            );
            foreach ($leadstatus as $value => $label) {
                if($result['leadstatus']==$value)
                {
                 $data .='<div class="row mt-1 mb-1"><label><strong>Lead Status:</strong>: '.$label.'</label></div>';
                }
                else
                {
                   
                }
            }
            $timestampcreationdate = strtotime($result['creationdate']);
            $creationdate = date("d-m-Y h:i A", $timestampcreationdate);
            $timestampupdatedate = strtotime($result['updatedate']);
            $updatedate = date("d-m-Y h:i A", $timestampupdatedate);
            $data .='<div class="row mt-1 mb-1"><label><strong> Created Date</strong>: '.$creationdate.'</label></div>';
            $data .='<div class="row mt-1 mb-1"><label><strong> Updated Date</strong>: '.$updatedate.'</label></div>';
            $data .='</div>';
            $response = new WP_REST_Response($data);
            //echo $response;
           
            return $response;

     }
     public function viewmodalboxfast2sms(): WP_REST_Response
     {
        $database_helper = new DatabaseHelper();
        $tokenvalue=$_POST['nonce'];
        //$tnv="res";
        $tnv=sanitize_text_field($_POST['tnv']);
        ob_start();
        $result = $database_helper->getfrontendpopup();
        $data = array(
            'records' => $result,
            'tnv'=>$tnv,
        );
        include "view/popuplead.php";
        $htmlrecord = ob_get_clean();
        $response = new WP_REST_Response($htmlrecord,$tokenvalue);
        //echo $response;
        return $response;
    }
    public function frontendleadwithpopup(): WP_REST_RESPONSE
    {
        if(isset($_POST['fullname'])!=''){$fullname=sanitize_text_field($_POST['fullname']);} else {$fullname='';}
        if(isset($_POST['email'])!=''){$email=sanitize_text_field($_POST['email']);} else {$email='';}
        if(isset($_POST['phone'])!=''){$phone=sanitize_text_field($_POST['phone']);} else {$phone='';}
        if(isset($_POST['countryCode'])!=''){$countryCode=sanitize_text_field($_POST['countryCode']);} else {$countryCode='';}
        if(isset($_POST['poopuploadoption'])!=''){$poopuploadoption=sanitize_text_field($_POST['poopuploadoption']);} else {$poopuploadoption='';}
        if(isset($_POST['verifyemail'])!=''){$verifyemail=sanitize_text_field($_POST['verifyemail']);} else {$verifyemail='';}
        if(isset($_POST['verifymobnumber'])!=''){$verifymobnumber=sanitize_text_field($_POST['verifymobnumber']);} else {$verifymobnumber='';}
        $nonce = isset($_POST['tokenvalue']) ? sanitize_text_field($_POST['tokenvalue']) : '';
       /* echo "countryCode:".$countryCode."<br>";
        echo "verifyemail:".$verifyemail."<br>";
        echo "verifymobnumber:".$verifymobnumber."<br>";
        exit;*/
        if(isset($_POST['extravalue'])!='')
        {
            $extravalue=sanitize_text_field($_POST['extravalue']);
        }
        else
        {
            $extravalue='';
        }
        $tokenvalue = $extravalue;
        $database_helper = new DatabaseHelper();
        $resultchecktokencheck = $database_helper->checktokenvaluebeforeinsert($nonce);
       
       
        if (!wp_verify_nonce($nonce, $tokenvalue)) {
            // Nonce verification failed, handle the error
            //wp_send_json_error('Nonce verification failed.');
            $html = array(
                'message' => 'false',
                'otpveification' => 'false',
                'messagetext' => '<div class="alert alert-danger" role="alert">Token verification failed.</div>',
                'data' => '',
            );
        }
        if($resultchecktokencheck=='true')
        {
           
            $html = array(
                'message' => 'false',
                'otpveification' => 'false',
                'messagetext' => '<div class="alert alert-danger" role="alert">Token verification failed.</div>',
                'data' => '',
            );
        }
        else
        {
       
                $current_date_time = date('Y-m-d H:i:s');

                if(isset($_SERVER['HTTP_CF_CONNECTING_IP'])){
                    $_SERVER['REMOTE_ADDR']=$_SERVER['HTTP_CF_CONNECTING_IP'];
                }

                $user_ip = $_SERVER['REMOTE_ADDR'];
               
                /* Check if mobilenumber or email are exist in database or not code start*/
                $resultcheck = $database_helper->checkrecordexist($email,$phone,$verifyemail,$verifymobnumber);
                $ipaddresscounter = $database_helper->checkipaddresscounter($user_ip);//check IP address can not be more than 5
        
    
                    if($resultcheck=='true')
                    {
                    
                        $html = array(
                            'message' => $resultcheck,
                            'otpveification'=>'false',
                            'messagetext'=>'<div class="alert alert-danger" role="alert">Already registered</div>',
                            'data'=>'',
                        );

                    
                       
                            $cookie_name ='popuploadoption';
                            $cookie_value = $poopuploadoption;
                            $cookie_path = '/';
                            $cookie_domain = $_SERVER['HTTP_HOST'];
                            setcookie($cookie_name, $cookie_value, time() + 86400, $cookie_path, $cookie_domain);

                        
                    }
                
                    else if($ipaddresscounter<=5)
                    {
                      
                                $database_helper = new DatabaseHelper();
                            
                                    
                                    if($verifyemail=='yes' && $verifymobnumber=='')
                                    {
                                        $FourDigitRandomNumberemail = mt_rand(222222,888888);
                                   
                                            $subject='Email Verify OTP';
                                            $message='Email verify OTP is: '.$FourDigitRandomNumberemail.'';
                                          
                                            $email_template = '<table cellspacing="0" cellpadding="0" border="0" width="100%" bgcolor="#f4f4f4">
                                            <tr>
                                                <td align="center" style="padding: 20px;">
                                                    <table cellspacing="0" cellpadding="0" border="0" width="600" style="background-color: #ffffff; box-shadow: 0 4px 8px rgba(0, 0, 0, 0.2);">
                                                        <tr>
                                                            <td align="center" style="padding: 20px;">
                                                                <h1 style="color: #333;">Email Verify OTP</h1>
                                                                </td>
                                                        </tr>
                                                        <tr>
                                                            <td align="center" style="padding: 20px;">
                                                                <table cellspacing="0" cellpadding="0" border="0" width="100%">
                                                                   
                                                                    <tr>
                                                                       
                                                                        <td align="center" style="padding: 10px;">
                                                                        '.$message.'
                                                                        </td>
                                                                    </tr>
                                                                </table>
                                                            </td>
                                                        </tr>
                                                    </table>
                                                </td>
                                            </tr>
                                        </table>';
                                            $recipient_name = 'Fast2sms'; // Replace with the recipient's name
                                            $email_subject = $subject; // Replace with your email subject
                                            $headers = array(
                                                'Content-Type: text/html; charset=UTF-8',
                                            );
                                            $email_sent = wp_mail($email, $email_subject, $email_template, $headers);
                                            $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
                                            $characterSetLength = strlen($characters);
                                            $length=15;
                                            $uniqueRequestId = '';
                                            for ($i = 0; $i < $length; $i++) {
                                                $uniqueRequestId .= $characters[random_int(0, $characterSetLength - 1)];
                                            }

                                            

                                                $OTP_data_insert = array(
                                                    'countrycode'=>$countryCode,
                                                    'fullname'=>$fullname,
                                                    'email'=>$email,
                                                    'mobilenumber' => '',
                                                    'emailotpstatus'=>'no',
                                                    'mobileotpcode' => '',
                                                    'emailotpcode'=>$FourDigitRandomNumberemail,
                                                    'mobileotpstatus'=>'no',
                                                    'tokenvalue'=>$nonce,
                                                    'source'=>'Popup',
                                                    'emailrequest_id' => $uniqueRequestId,
                                                    'mobilerequest_id' => '',
                                                    'ipaddress' => $user_ip,
                                                    'creationdate' => $current_date_time,
                                                    'updatedate'=>$current_date_time,
                                                );  
                                                $result = $database_helper->insertotpinfo($OTP_data_insert);
                                                $htmlrecord = array(
                                                    'fullname' => $fullname,
                                                    'email' => $email,
                                                    'emailrequest_id' => $uniqueRequestId,
                                                    'mobilerequest_id' => '',
                                                    'mobilenumberhtml' => $phone,
                                                    'countrycode'=>$countryCode,
                                                
                                                ); 
                                                $html = array(
                                                    'message' => $result['response'],
                                                    'otpveification'=>'true',
                                                    'mobile'=>'false',
                                                    'email'=>'true',
                                                    'messagetext'=>'',
                                                    'otid'=>$result['otid'],
                                                    'data'=>$htmlrecord,
                                                );
                        
                                                 
                                                    $cookie_name ='popuploadoption';
                                                    $cookie_value = $poopuploadoption;
                                                    $cookie_path = '/';
                                                    $cookie_domain = $_SERVER['HTTP_HOST'];
                                                    setcookie($cookie_name, $cookie_value, time() + 86400, $cookie_path, $cookie_domain);


                                            
                                    }
                                   
                                    if($verifyemail=='no' && $verifymobnumber=='')
                                    {
                                        $FourDigitRandomNumberemail="";
                                        $uniqueRequestId='';

                                        $OTP_data_insert = array(
                                            'countrycode'=>$countryCode,
                                            'fullname'=>$fullname,
                                            'email'=>$email,
                                            'mobilenumber' =>'',
                                            'emailotpstatus'=>'no',
                                            'mobileotpcode' => '',
                                            'emailotpcode'=>'',
                                            'mobileotpstatus'=>'no',
                                            'tokenvalue'=>$nonce,
                                            'source'=>'Popup',
                                            'emailrequest_id' => $uniqueRequestId,
                                            'mobilerequest_id' => '',
                                            'ipaddress' => $user_ip,
                                            'creationdate' => $current_date_time,
                                            'updatedate'=>$current_date_time,
                                        );  
                                        $result = $database_helper->insertotpinfo($OTP_data_insert);
                                        $htmlrecord = array(
                                            'fullname' => $fullname,
                                            'email' => $email,
                                            'emailrequest_id' => '',
                                            'mobilerequest_id' => '',
                                            'mobilenumberhtml' => $phone,
                                            'countrycode'=>$countryCode,
                                        
                                        ); 
                                        $html = array(
                                            'message' => 'false',
                                            'otpveification'=>'false',
                                            'mobile'=>'false',
                                            'email'=>'false',
                                            'messagetext'=>'',
                                            'otid'=>$result['otid'],
                                            'data'=>$htmlrecord,
                                        );
                
                                         
                                            $cookie_name ='popuploadoption';
                                            $cookie_value = $poopuploadoption;
                                            $cookie_path = '/';
                                            $cookie_domain = $_SERVER['HTTP_HOST'];
                                            setcookie($cookie_name, $cookie_value, time() + 86400, $cookie_path, $cookie_domain);

                                    }
                                    if($verifymobnumber=='yes' && $verifyemail=='')
                                    {
                                        $result = $database_helper->getapiinfo();
                                          
                                        
                                        
                                                        $FourDigitRandomNumber = mt_rand(111111,999999);
                                                    if($countryCode=="+91")
                                                    {
                                                        if(isset($result) && count($result) > 0)  //check if api key is exist or not if yes then we call api code for OTP verification code
                                                        {
                                                        
                                                            // Get API key from the result array
                                                        $apikey = $result[0]['apikey'];

                                                        // Prepare the request parameters
                                                        $request_url = "https://www.fast2sms.com/dev/bulkV2?f2s_ref=wp_lead_plugin&authorization=" . $apikey . "&variables_values=" . $FourDigitRandomNumber . "&route=otp&numbers=" . $phone;
                                                        $request_args = array(
                                                            'timeout' => 30,
                                                            'sslverify' => false,
                                                            'headers' => array(
                                                                'cache-control' => 'no-cache',
                                                            ),
                                                        );

                                                        // Make the HTTP GET request using wp_remote_get
                                                        $response = wp_remote_get($request_url, $request_args);
                                                        if (is_wp_error($response)) {
                                                            $html = array(
                                                                'message' => 'false',
                                                                'otpveification' => 'false',
                                                                'messagetext' => '<div class="alert alert-danger" role="alert">Mobile number not in correct format or SMS API error</div>',
                                                                'data' => $response->get_error_message(),
                                                            );
                                                        }
                                                        else
                                                        {
                                                         // Decode the JSON response
                                                            $mobiledataapi = json_decode(wp_remote_retrieve_body($response), true);

                                                            // Check the 'return' key in the response
                                                            if ($mobiledataapi['return'] != '1') {
                                                                $html = array(
                                                                    'message' => 'false',
                                                                    'otpveification' => 'false',
                                                                    'messagetext' => '<div class="alert alert-danger" role="alert">Mobile number not in correct format or SMS API error</div>',
                                                                    'data' => $mobiledataapi,
                                                                );
                                                            }
                                                        else
                                                        {
                                                            $OTP_data_insert = array(
                                                                'countrycode'=>$countryCode,
                                                                'fullname'=>$fullname,
                                                                'email'=>$email,
                                                                'mobilenumber' => $phone,
                                                                'emailotpstatus'=>'no',
                                                                'mobileotpcode' => $FourDigitRandomNumber,
                                                                'emailotpcode'=>'',
                                                                'mobileotpstatus'=>'no',
                                                                'tokenvalue'=>$nonce,
                                                                'source'=>'Popup',
                                                                'emailrequest_id' =>'',
                                                                'mobilerequest_id' => $mobiledataapi['request_id'],
                                                                'ipaddress' => $user_ip,
                                                                'creationdate' => $current_date_time,
                                                                'updatedate'=>$current_date_time,
                                                            );  
                                                            $htmlrecord = array(
                                                                'fullname' => $fullname,
                                                                'email' => $email,
                                                                'emailrequest_id' => '',
                                                                'mobilerequest_id' => $mobiledataapi['request_id'],
                                                                'mobilenumberhtml' => $phone,
                                                                'countrycode'=>$countryCode,
                                                            
                                                            ); 
                                                            $result = $database_helper->insertotpinfo($OTP_data_insert);
                                                        
                                                        
                                                                $html = array(
                                                                    'message' => $result['response'],
                                                                    'otpveification'=>'true',
                                                                    'mobile'=>'true',
                                                                    'email'=>'false',
                                                                    'messagetext'=>'',
                                                                    'otid'=>$result['otid'],
                                                                    'data'=>$htmlrecord,
                                                                );
                                                        
                                                        
                                                                
                                                                $cookie_name ='popuploadoption';
                                                                $cookie_value = $poopuploadoption;
                                                                $cookie_path = '/';
                                                                $cookie_domain = $_SERVER['HTTP_HOST'];
                                                                setcookie($cookie_name, $cookie_value, time() + 86400, $cookie_path, $cookie_domain);
                                                        }
                                                        }
                                                      }
                                                      else
                                                      {
                                                        $html = array(
                                                            'message' => 'false',
                                                            'otpveification'=>'false',
                                                            'messagetext'=>'<div class="alert alert-danger" role="alert">SMS API KEY not found</div>',
                                                            'data'=>''
                                                        ); 
                
                                                      }
                                                        
                                                    } //if country code is +91
                                                
                                                    else
                                                    {
                                                        $OTP_data_insert = array(
                                                            'countrycode'=>$countryCode,
                                                            'fullname'=>$fullname,
                                                            'email'=>$email,
                                                            'mobilenumber' => $phone,
                                                            'emailotpstatus'=>'no',
                                                            'mobileotpcode' => '',
                                                            'emailotpcode'=>'',
                                                            'mobileotpstatus'=>'no',
                                                            'tokenvalue'=>$nonce,
                                                            'source'=>'Popup',
                                                            'emailrequest_id' =>'',
                                                            'mobilerequest_id' => '',
                                                            'ipaddress' => $user_ip,
                                                            'creationdate' => $current_date_time,
                                                            'updatedate'=>$current_date_time,
                                                        );  
                                                        $result = $database_helper->insertotpinfo($OTP_data_insert);
                                                        $htmlrecord = array(
                                                            'fullname' => $fullname,
                                                            'email' => $email,
                                                            'emailrequest_id' => '',
                                                            'mobilerequest_id' => '',
                                                            'mobilenumberhtml' => $phone,
                                                            'countrycode'=>$countryCode,
                                                        
                                                        ); 
                                                        $html = array(
                                                            'message' => 'false',
                                                            'otpveification'=>'false',
                                                            'mobile'=>'false',
                                                            'email'=>'false',
                                                            'messagetext'=>'',
                                                            'otid'=>$result['otid'],
                                                            'data'=>$htmlrecord,
                                                        );
                                
                                        
                                                            $cookie_name ='popuploadoption';
                                                            $cookie_value = $poopuploadoption;
                                                            $cookie_path = '/';
                                                            $cookie_domain = $_SERVER['HTTP_HOST'];
                                                            setcookie($cookie_name, $cookie_value, time() + 86400, $cookie_path, $cookie_domain);
                                            
                                                    }//else if conuntry code is non indian
                                     
                                      }
                                      
                                  

                                    if($verifymobnumber=='no' && $verifyemail=='')

                                    {

                                            $OTP_data_insert = array(
                                                'countrycode'=>$countryCode,
                                                'fullname'=>$fullname,
                                                'email'=>$email,
                                                'mobilenumber' => $phone,
                                                'emailotpstatus'=>'no',
                                                'mobileotpcode' => '',
                                                'emailotpcode'=>'',
                                                'mobileotpstatus'=>'no',
                                                'tokenvalue'=>$nonce,
                                                'source'=>'Popup',
                                                'emailrequest_id' =>'',
                                                'mobilerequest_id' => '',
                                                'ipaddress' => $user_ip,
                                                'creationdate' => $current_date_time,
                                                'updatedate'=>$current_date_time,
                                            );  
                                            $result = $database_helper->insertotpinfo($OTP_data_insert);
                                            $htmlrecord = array(
                                                'fullname' => $fullname,
                                                'email' => $email,
                                                'emailrequest_id' => '',
                                                'mobilerequest_id' => '',
                                                'mobilenumberhtml' => $phone,
                                                'countrycode'=>$countryCode,
                                            
                                            ); 
                                            $html = array(
                                                'message' => 'false',
                                                'otpveification'=>'false',
                                                'mobile'=>'false',
                                                'email'=>'false',
                                                'messagetext'=>'',
                                                'otid'=>$result['otid'],
                                                'data'=>$htmlrecord,
                                            );
                    
                             
                                                $cookie_name ='popuploadoption';
                                                $cookie_value = $poopuploadoption;
                                                $cookie_path = '/';
                                                $cookie_domain = $_SERVER['HTTP_HOST'];
                                                setcookie($cookie_name, $cookie_value, time() + 86400, $cookie_path, $cookie_domain);
                                  
                                    
                                    }

                                    //if both email and numbers are yes

                                    if($verifymobnumber=='yes' && $verifyemail=='yes')

                                    {
                                        $result = $database_helper->getapiinfo();
                                        
                                        $FourDigitRandomNumberemail = mt_rand(222222,888888);
                                   
                                            $subject='Email Verify OTP';
                                            $message='Email verify OTP is: '.$FourDigitRandomNumberemail.'';
                                          
                                            $email_template = '<table cellspacing="0" cellpadding="0" border="0" width="100%" bgcolor="#f4f4f4">
                                            <tr>
                                                <td align="center" style="padding: 20px;">
                                                    <table cellspacing="0" cellpadding="0" border="0" width="600" style="background-color: #ffffff; box-shadow: 0 4px 8px rgba(0, 0, 0, 0.2);">
                                                        <tr>
                                                            <td align="center" style="padding: 20px;">
                                                                <h1 style="color: #333;">Email Verify OTP</h1>
                                                                </td>
                                                        </tr>
                                                        <tr>
                                                            <td align="center" style="padding: 20px;">
                                                                <table cellspacing="0" cellpadding="0" border="0" width="100%">
                                                                   
                                                                    <tr>
                                                                      
                                                                        <td align="center" style="padding: 10px;">
                                                                        '.$message.'
                                                                        </td>
                                                                    </tr>
                                                                </table>
                                                            </td>
                                                        </tr>
                                                    </table>
                                                </td>
                                            </tr>
                                        </table>';
                                            $recipient_name = 'Fast2sms'; // Replace with the recipient's name
                                            $email_subject = $subject; // Replace with your email subject
                                            $headers = array(
                                                'Content-Type: text/html; charset=UTF-8',
                                            );
                                            $email_sent = wp_mail($email, $email_subject, $email_template, $headers);
                                            $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
                                            $characterSetLength = strlen($characters);
                                            $length=15;
                                            $uniqueRequestId = '';
                                            for ($i = 0; $i < $length; $i++) {
                                                $uniqueRequestId .= $characters[random_int(0, $characterSetLength - 1)];
                                            }


                                            $FourDigitRandomNumber = mt_rand(111111,999999);
                                            if($countryCode == "+91"){
                                            if(isset($result) && count($result) > 0) {  //check if api key is exist or not if yes then we call api code for OTP verification code
                                                
                                                // Get API key from the result array
                                            $apikey = $result[0]['apikey'];

                                            // Prepare the request parameters
                                            $request_url = "https://www.fast2sms.com/dev/bulkV2?f2s_ref=wp_lead_plugin&authorization=" . $apikey . "&variables_values=" . $FourDigitRandomNumber . "&route=otp&numbers=" . $phone;
                                            $request_args = array(
                                                'timeout' => 30,
                                                'sslverify' => false,
                                                'headers' => array(
                                                    'cache-control' => 'no-cache',
                                                ),
                                            );

                                            // Make the HTTP GET request using wp_remote_get
                                            $response = wp_remote_get($request_url, $request_args);

                                            // Check for errors
                                            if (is_wp_error($response)) {
                                                $html = array(
                                                    'message' => 'false',
                                                    'otpveification' => 'false',
                                                    'messagetext' => '<div class="alert alert-danger" role="alert">Mobile number not in correct format or SMS API error</div>',
                                                    'data' => $response->get_error_message(),
                                                );
                                            } else {
                                                // Decode the JSON response
                                                $mobiledataapi = json_decode(wp_remote_retrieve_body($response), true);

                                                // Check the 'return' key in the response
                                                if ($mobiledataapi['return'] != '1') {
                                                    $html = array(
                                                        'message' => 'false',
                                                        'otpveification' => 'false',
                                                        'messagetext' => '<div class="alert alert-danger" role="alert">Mobile number not in correct format or SMS API error</div>',
                                                        'data' => $mobiledataapi,
                                                    );
                                                } else {
                                                    // Your OTP data insert code
                                                    $OTP_data_insert = array(
                                                        'countrycode' => $countryCode,
                                                        'fullname' => $fullname,
                                                        'email' => $email,
                                                        'mobilenumber' => $phone,
                                                        'emailotpstatus' => 'no',
                                                        'mobileotpcode' => $FourDigitRandomNumber,
                                                        'emailotpcode' => $FourDigitRandomNumberemail,
                                                        'mobileotpstatus' => 'no',
                                                        'tokenvalue' => $nonce,
                                                        'source' => 'Popup',
                                                        'emailrequest_id' => $uniqueRequestId,
                                                        'mobilerequest_id' => $mobiledataapi['request_id'],
                                                        'ipaddress' => $user_ip,
                                                        'creationdate' => $current_date_time,
                                                        'updatedate' => $current_date_time,
                                                    );

                                                    // Your HTML record array
                                                    $htmlrecord = array(
                                                        'fullname' => $fullname,
                                                        'email' => $email,
                                                        'emailrequest_id' => $uniqueRequestId,
                                                        'mobilerequest_id' => $mobiledataapi['request_id'],
                                                        'mobilenumberhtml' => $phone,
                                                        'countrycode' => $countryCode,
                                                    );

                                                    // Insert OTP data into the database
                                                    $result = $database_helper->insertotpinfo($OTP_data_insert);

                                                    // Your response array
                                                    $html = array(
                                                        'message' => $result['response'],
                                                        'otpveification' => 'true',
                                                        'mobile' => 'true',
                                                        'email' => 'true',
                                                        'messagetext' => '',
                                                        'otid' => $result['otid'],
                                                        'data' => $htmlrecord,
                                                    );

                                                    // Set cookie
                                                    $cookie_name = 'popuploadoption';
                                                    $cookie_value = $poopuploadoption;
                                                    $cookie_path = '/';
                                                    $cookie_domain = $_SERVER['HTTP_HOST'];
                                                    setcookie($cookie_name, $cookie_value, time() + 86400, $cookie_path, $cookie_domain);
                                                }
                                            }


                                            } //if country code is +91
                                            else
                                            {
                                                $html = array(
                                                    'message' => 'false',
                                                    'otpveification'=>'false',
                                                    'messagetext'=>'<div class="alert alert-danger" role="alert">SMS API KEY not found</div>',
                                                    'data'=>''
                                                ); 
                                            }
                                        }
                                            else
                                            {
                                                $OTP_data_insert = array(
                                                    'countrycode'=>$countryCode,
                                                    'fullname'=>$fullname,
                                                    'email'=>$email,
                                                    'mobilenumber' => $phone,
                                                    'emailotpstatus'=>'no',
                                                    'mobileotpcode' => '',
                                                    'emailotpcode'=>$FourDigitRandomNumberemail,
                                                    'mobileotpstatus'=>'no',
                                                    'tokenvalue'=>$nonce,
                                                    'source'=>'Popup',
                                                    'emailrequest_id' => $uniqueRequestId,
                                                    'mobilerequest_id' => '',
                                                    'ipaddress' => $user_ip,
                                                    'creationdate' => $current_date_time,
                                                    'updatedate'=>$current_date_time,
                                                );  
                                                $result = $database_helper->insertotpinfo($OTP_data_insert);
                                                $htmlrecord = array(
                                                    'fullname' => $fullname,
                                                    'email' => $email,
                                                    'emailrequest_id' => $uniqueRequestId,
                                                    'mobilerequest_id' => '',
                                                    'mobilenumberhtml' => $phone,
                                                    'countrycode'=>$countryCode,
                                                
                                                ); 
                                                $html = array(
                                                    'message' => $result['response'],
                                                    'otpveification'=>'true',
                                                    'mobile'=>'false',
                                                    'email'=>'true',
                                                    'messagetext'=>'',
                                                    'otid'=>$result['otid'],
                                                    'data'=>$htmlrecord,
                                                );
                        
                                 
                                                    $cookie_name ='popuploadoption';
                                                    $cookie_value = $poopuploadoption;
                                                    $cookie_path = '/';
                                                    $cookie_domain = $_SERVER['HTTP_HOST'];
                                                    setcookie($cookie_name, $cookie_value, time() + 86400, $cookie_path, $cookie_domain);
                                      
                                             }//else if conuntry code is non indian

                                        }
                                       

                                    if($verifymobnumber=='yes' && $verifyemail=='no')

                                    {

                                        
                                            $FourDigitRandomNumber = mt_rand(111111,999999);
                                            if($countryCode=="+91")
                                            {
                                                $result = $database_helper->getapiinfo();
                                                if(isset($result) && count($result) > 0)  //check if api key is exist or not if yes then we call api code for OTP verification code
                                                { 
                                                                                                    // Get API key from the result array
                                                    $apikey = $result[0]['apikey'];

                                                    // Prepare the request parameters
                                                    $request_url = "https://www.fast2sms.com/dev/bulkV2?f2s_ref=wp_lead_plugin&authorization=" . $apikey . "&variables_values=" . $FourDigitRandomNumber . "&route=otp&numbers=" . $phone;
                                                    $request_args = array(
                                                        'timeout' => 30,
                                                        'sslverify' => false,
                                                        'headers' => array(
                                                            'cache-control' => 'no-cache',
                                                        ),
                                                    );

                                                    // Make the HTTP GET request using wp_remote_get
                                                    $response = wp_remote_get($request_url, $request_args);

                                                    // Check for errors
                                                    if (is_wp_error($response)) {
                                                        $html = array(
                                                            'message' => 'false',
                                                            'otpveification' => 'false',
                                                            'messagetext' => '<div class="alert alert-danger" role="alert">Mobile number not in correct format or SMS API error</div>',
                                                            'data' => $response->get_error_message(),
                                                        );
                                                    } else {
                                                        // Decode the JSON response
                                                        $mobiledataapi = json_decode(wp_remote_retrieve_body($response), true);

                                                        // Check the 'return' key in the response
                                                        if ($mobiledataapi['return'] != '1') {
                                                            $html = array(
                                                                'message' => 'false',
                                                                'otpveification' => 'false',
                                                                'messagetext' => '<div class="alert alert-danger" role="alert">Mobile number not in correct format or SMS API error</div>',
                                                                'data' => $mobiledataapi,
                                                            );
                                                        } else {
                                                            // Your OTP data insert code
                                                            $OTP_data_insert = array(
                                                                'countrycode' => $countryCode,
                                                                'fullname' => $fullname,
                                                                'email' => $email,
                                                                'mobilenumber' => $phone,
                                                                'emailotpstatus' => 'no',
                                                                'mobileotpcode' => $FourDigitRandomNumber,
                                                                'emailotpcode' => '',
                                                                'mobileotpstatus' => 'no',
                                                                'tokenvalue' => $nonce,
                                                                'source' => 'Popup',
                                                                'emailrequest_id' => '',
                                                                'mobilerequest_id' => $mobiledataapi['request_id'],
                                                                'ipaddress' => $user_ip,
                                                                'creationdate' => $current_date_time,
                                                                'updatedate' => $current_date_time,
                                                            );

                                                            // Your HTML record array
                                                            $htmlrecord = array(
                                                                'fullname' => $fullname,
                                                                'email' => $email,
                                                                'emailrequest_id' => '',
                                                                'mobilerequest_id' => $mobiledataapi['request_id'],
                                                                'mobilenumberhtml' => $phone,
                                                                'countrycode' => $countryCode,
                                                            );

                                                            // Insert OTP data into the database
                                                            $result = $database_helper->insertotpinfo($OTP_data_insert);

                                                            // Your response array
                                                            $html = array(
                                                                'message' => $result['response'],
                                                                'otpveification' => 'true',
                                                                'mobile' => 'true',
                                                                'email' => 'false',
                                                                'messagetext' => '',
                                                                'otid' => $result['otid'],
                                                                'data' => $htmlrecord,
                                                            );

                                                            // Set cookie
                                                            $cookie_name = 'popuploadoption';
                                                            $cookie_value = $poopuploadoption;
                                                            $cookie_path = '/';
                                                            $cookie_domain = $_SERVER['HTTP_HOST'];
                                                            setcookie($cookie_name, $cookie_value, time() + 86400, $cookie_path, $cookie_domain);
                                                        }
                                                    }

                                                }
                                                else
                                                {
                                                    $html = array(
                                                        'message' => 'false',
                                                        'otpveification'=>'false',
                                                        'messagetext'=>'<div class="alert alert-danger" role="alert">SMS API KEY not found</div>',
                                                        'data'=>''
                                                    ); 
            
                                                }
                                                
                                            } //if country code is +91
                                          
                                            else
                                            {
                                                $OTP_data_insert = array(
                                                    'countrycode'=>$countryCode,
                                                    'fullname'=>$fullname,
                                                    'email'=>$email,
                                                    'mobilenumber' => $phone,
                                                    'emailotpstatus'=>'no',
                                                    'mobileotpcode' => '',
                                                    'emailotpcode'=>'',
                                                    'mobileotpstatus'=>'no',
                                                    'tokenvalue'=>$nonce,
                                                    'source'=>'Popup',
                                                    'emailrequest_id' => '',
                                                    'mobilerequest_id' => '',
                                                    'ipaddress' => $user_ip,
                                                    'creationdate' => $current_date_time,
                                                    'updatedate'=>$current_date_time,
                                                );  
                                                $result = $database_helper->insertotpinfo($OTP_data_insert);
                                                $htmlrecord = array(
                                                    'fullname' => $fullname,
                                                    'email' => $email,
                                                    'emailrequest_id' => '',
                                                    'mobilerequest_id' => '',
                                                    'mobilenumberhtml' => $phone,
                                                    'countrycode'=>$countryCode,
                                                
                                                ); 
                                                $html = array(
                                                    'message' => 'false',
                                                    'otpveification'=>'false',
                                                    'mobile'=>'false',
                                                    'email'=>'false',
                                                    'messagetext'=>'',
                                                    'otid'=>$result['otid'],
                                                    'data'=>$htmlrecord,
                                                );
                        
                                 
                                                    $cookie_name ='popuploadoption';
                                                    $cookie_value = $poopuploadoption;
                                                    $cookie_path = '/';
                                                    $cookie_domain = $_SERVER['HTTP_HOST'];
                                                    setcookie($cookie_name, $cookie_value, time() + 86400, $cookie_path, $cookie_domain);
                                      
                                             }//else if conuntry code is non indian

                                            

                                    }//verifyemail yes and mobilenumber no




                                    if($verifymobnumber=='no' && $verifyemail=='yes')

                                    {

                                        $FourDigitRandomNumberemail = mt_rand(222222,888888);
                                   
                                            $subject='Email Verify OTP';
                                            $message='Email verify OTP is: '.$FourDigitRandomNumberemail.'';
                                          
                                            $email_template = '<table cellspacing="0" cellpadding="0" border="0" width="100%" bgcolor="#f4f4f4">
                                            <tr>
                                                <td align="center" style="padding: 20px;">
                                                    <table cellspacing="0" cellpadding="0" border="0" width="600" style="background-color: #ffffff; box-shadow: 0 4px 8px rgba(0, 0, 0, 0.2);">
                                                        <tr>
                                                            <td align="center" style="padding: 20px;">
                                                                <h1 style="color: #333;">Email Verify OTP</h1>
                                                               </td>
                                                        </tr>
                                                        <tr>
                                                            <td align="center" style="padding: 20px;">
                                                                <table cellspacing="0" cellpadding="0" border="0" width="100%">
                                                                   
                                                                    <tr>
                                                                       
                                                                        <td align="center" style="padding: 10px;">
                                                                        '.$message.'
                                                                        </td>
                                                                    </tr>
                                                                </table>
                                                            </td>
                                                        </tr>
                                                    </table>
                                                </td>
                                            </tr>
                                        </table>';
                                            $recipient_name = 'Fast2sms'; // Replace with the recipient's name
                                            $email_subject = $subject; // Replace with your email subject
                                            $headers = array(
                                                'Content-Type: text/html; charset=UTF-8',
                                            );
                                            $email_sent = wp_mail($email, $email_subject, $email_template, $headers);
                                            $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
                                            $characterSetLength = strlen($characters);
                                            $length=15;
                                            $uniqueRequestId = '';
                                            for ($i = 0; $i < $length; $i++) {
                                                $uniqueRequestId .= $characters[random_int(0, $characterSetLength - 1)];
                                            }


                                           
                                            
                                                $OTP_data_insert = array(
                                                    'countrycode'=>$countryCode,
                                                    'fullname'=>$fullname,
                                                    'email'=>$email,
                                                    'mobilenumber' => $phone,
                                                    'emailotpstatus'=>'no',
                                                    'mobileotpcode' => '',
                                                    'emailotpcode'=>$FourDigitRandomNumberemail,
                                                    'mobileotpstatus'=>'no',
                                                    'tokenvalue'=>$nonce,
                                                    'source'=>'Popup',
                                                    'emailrequest_id' => $uniqueRequestId,
                                                    'mobilerequest_id' => '',
                                                    'ipaddress' => $user_ip,
                                                    'creationdate' => $current_date_time,
                                                    'updatedate'=>$current_date_time,
                                                );  
                                                $result = $database_helper->insertotpinfo($OTP_data_insert);
                                                $htmlrecord = array(
                                                    'fullname' => $fullname,
                                                    'email' => $email,
                                                    'emailrequest_id' => $uniqueRequestId,
                                                    'mobilerequest_id' => '',
                                                    'mobilenumberhtml' => $phone,
                                                    'countrycode'=>$countryCode,
                                                
                                                ); 
                                                $html = array(
                                                    'message' => $result['response'],
                                                    'otpveification'=>'true',
                                                    'mobile'=>'false',
                                                    'email'=>'true',
                                                    'messagetext'=>'',
                                                    'otid'=>$result['otid'],
                                                    'data'=>$htmlrecord,
                                                );
                        
                                 
                                                    $cookie_name ='popuploadoption';
                                                    $cookie_value = $poopuploadoption;
                                                    $cookie_path = '/';
                                                    $cookie_domain = $_SERVER['HTTP_HOST'];
                                                    setcookie($cookie_name, $cookie_value, time() + 86400, $cookie_path, $cookie_domain);
                                      
                                            

                                            

                                    }//if mobile no and email yes

                                    if($verifymobnumber=='no' && $verifyemail=='no')

                                    {

                                            $OTP_data_insert = array(
                                                'countrycode'=>$countryCode,
                                                'fullname'=>$fullname,
                                                'email'=>$email,
                                                'mobilenumber' => $phone,
                                                'emailotpstatus'=>'no',
                                                'mobileotpcode' => '',
                                                'emailotpcode'=>'',
                                                'mobileotpstatus'=>'no',
                                                'tokenvalue'=>$nonce,
                                                'source'=>'Popup',
                                                'emailrequest_id' => '',
                                                'mobilerequest_id' => '',
                                                'ipaddress' => $user_ip,
                                                'creationdate' => $current_date_time,
                                                'updatedate'=>$current_date_time,
                                            );  
                                            $result = $database_helper->insertotpinfo($OTP_data_insert);
                                            $htmlrecord = array(
                                                'fullname' => $fullname,
                                                'email' => $email,
                                                'emailrequest_id' => '',
                                                'mobilerequest_id' => '',
                                                'mobilenumberhtml' => $phone,
                                                'countrycode'=>$countryCode,
                                            
                                            ); 
                                            $html = array(
                                                'message' => 'false',
                                                'otpveification'=>'false',
                                                'mobile'=>'false',
                                                'email'=>'false',
                                                'messagetext'=>'',
                                                'otid'=>$result['otid'],
                                                'data'=>$htmlrecord,
                                            );
                    
                             
                                                $cookie_name ='popuploadoption';
                                                $cookie_value = $poopuploadoption;
                                                $cookie_path = '/';
                                                $cookie_domain = $_SERVER['HTTP_HOST'];
                                                setcookie($cookie_name, $cookie_value, time() + 86400, $cookie_path, $cookie_domain);
                                  
                                    
                                    }
                           


                     
                    }//to many if conidtion end
                    else
                    {
                        //echo "counter:". $ipaddresscounter;
                    
                        $html = array(
                            'message' => 'false',
                            'otpveification'=>'false',
                            'messagetext'=>'<div class="alert alert-danger" role="alert">Too many request</div>',
                            'data'=>''
                        ); 
                            
                            
                                $cookie_name ='popuploadoption';
                                $cookie_value = $poopuploadoption;
                                $cookie_path = '/';
                                $cookie_domain = $_SERVER['HTTP_HOST'];
                                setcookie($cookie_name, $cookie_value, time() + 86400, $cookie_path, $cookie_domain);
                            /* delete token value because of we already inserted record and need to stop use same token and insert the record */
                            
                            //$database_helper->deletetokenrecord();
                            /*code end */
                    } //too many else condition end
            
                } //if token and everything is verified 
                 $response = new WP_REST_Response($html);
                 return $response;
            }
    public function emailresendotplink(): WP_REST_RESPONSE
    { 
        if(isset($_POST['otid'])!=''){$otid=sanitize_text_field($_POST['otid']);} else {$otid='';}
        
            if(isset($_POST['email'])!=''){$email=sanitize_text_field($_POST['email']);} else {$email='';}
            $database_helper = new DatabaseHelper();
            $result = $database_helper->emailresendotplinkcheck($otid);
if($result == 'false') {
    $FourDigitRandomNumberemail = mt_rand(222222, 888888);

    $subject = 'Email Verify OTP';
    $message = 'Email verify OTP is: ' . $FourDigitRandomNumberemail . '';

    $email_template = '<table cellspacing="0" cellpadding="0" border="0" width="100%" bgcolor="#f4f4f4">
            <tr>
                <td align="center" style="padding: 20px;">
                    <table cellspacing="0" cellpadding="0" border="0" width="600" style="background-color: #ffffff; box-shadow: 0 4px 8px rgba(0, 0, 0, 0.2);">
                        <tr>
                            <td align="center" style="padding: 20px;">
                                <h1 style="color: #333;">Email Verify OTP</h1>
                                </td>
                        </tr>
                        <tr>
                            <td align="center" style="padding: 20px;">
                                <table cellspacing="0" cellpadding="0" border="0" width="100%">
                                   
                                    <tr>
                                       
                                        <td align="center" style="padding: 10px;">
                                        ' . $message . '
                                        </td>
                                    </tr>
                                </table>
                            </td>
                        </tr>
                    </table>
                </td>
            </tr>
        </table>';
    $recipient_name = 'Fast2sms'; // Replace with the recipient's name
    $email_subject = $subject; // Replace with your email subject
    $headers = array(
        'Content-Type: text/html; charset=UTF-8',
    );
    $email_sent = wp_mail($email, $email_subject, $email_template, $headers);
    $database_helper = new DatabaseHelper();
    $result = $database_helper->updateemailresendotplink($otid, $FourDigitRandomNumberemail);
    $html = array(
        'message' => $result,
    );
    $database_helper->updatemailresendotplinkflag($otid);
}
else
{
    $html = array(
        'message' => 'false',
    );  
}
            $response = new WP_REST_Response($html);
            return $response;
        
    }

    public function emailresendotplinkshortcode(): WP_REST_RESPONSE
    { 
         if(isset($_POST['lid'])!=''){$lid=sanitize_text_field($_POST['lid']);} else {$lid='';}
        if(isset($_POST['otid'])!=''){$otid=sanitize_text_field($_POST['otid']);} else {$otid='';}
        if(isset($_POST['email'])!=''){$email=sanitize_text_field($_POST['email']);} else {$email='';}
        $database_helper = new DatabaseHelper();
        $resultemailcheck = $database_helper->checkemailresendlinksend($otid,$email);
        $result = $database_helper->checkemailresendlinksendflag($otid);
        
        if($resultemailcheck=='true' && $result == 'false') {
        if(isset($otid) && $otid != '') {
        if(isset($_POST['email']) != '') {
            $email = sanitize_text_field($_POST['email']);
        } else {
            $email = '';
        }
        $FourDigitRandomNumberemail = mt_rand(222222, 888888);

        $subject = 'Email Verify OTP';
        $message = 'Email verify OTP is: ' . $FourDigitRandomNumberemail . '';

        $email_template = '<table cellspacing="0" cellpadding="0" border="0" width="100%" bgcolor="#f4f4f4">
            <tr>
                <td align="center" style="padding: 20px;">
                    <table cellspacing="0" cellpadding="0" border="0" width="600" style="background-color: #ffffff; box-shadow: 0 4px 8px rgba(0, 0, 0, 0.2);">
                        <tr>
                            <td align="center" style="padding: 20px;">
                                <h1 style="color: #333;">Email Verify OTP</h1>
                                </td>
                        </tr>
                        <tr>
                            <td align="center" style="padding: 20px;">
                                <table cellspacing="0" cellpadding="0" border="0" width="100%">
                                   
                                    <tr>
                                       
                                        <td align="center" style="padding: 10px;">
                                        ' . $message . '
                                        </td>
                                    </tr>
                                </table>
                            </td>
                        </tr>
                    </table>
                </td>
            </tr>
        </table>';
        $recipient_name = 'Fast2sms'; // Replace with the recipient's name
        $email_subject = $subject; // Replace with your email subject
        $headers = array(
            'Content-Type: text/html; charset=UTF-8',
        );
        $email_sent = wp_mail($email, $email_subject, $email_template, $headers);
        $database_helper = new DatabaseHelper();
        $result = $database_helper->updateemailresendotplink($otid, $FourDigitRandomNumberemail);
            if($result == 'true') {
                $html = array(
                    'message' => $result,
                );

            }
            $database_helper->updateemaileresndtotplinkflag($otid);
            }
        }
        else
        {
            $html = array(
                'message' => 'false',
            );  
        }
        $response = new WP_REST_Response($html);
        return $response;
    }

    public function mobileresendLink():WP_REST_RESPONSE
    {
        if(isset($_POST['lid'])!=''){$lid=sanitize_text_field($_POST['lid']);} else {$lid='';}
        if(isset($_POST['otid'])!=''){$otid=sanitize_text_field($_POST['otid']);} else {$otid='';}
        if(isset($_POST['phone'])!=''){$phone=sanitize_text_field($_POST['phone']);} else {$phone='';}
        $database_helper = new DatabaseHelper();
        $resultcheck = $database_helper->checkmobileresendlinksend($otid,$phone);
        $result = $database_helper->checkmobileresendlinksendcheckonlyflag($otid);
// Check conditions
if ($resultcheck == 'true' && $result == 'false') {
    // Your DatabaseHelper class and other functions
    $database_helper = new DatabaseHelper();
    
    // Get API key from the database
    $result = $database_helper->getapiinfo();
    $apikey = $result[0]['apikey'];

    // Generate a random 6-digit number
    $FourDigitRandomNumber = mt_rand(111111, 999999);

    // Prepare the request parameters
    $request_url = "https://www.fast2sms.com/dev/bulkV2?f2s_ref=wp_lead_plugin&authorization=" . $apikey . "&variables_values=" . $FourDigitRandomNumber . "&route=otp&numbers=" . $phone;
    $request_args = array(
        'timeout' => 30,
        'sslverify' => false,
        'headers' => array(
            'cache-control' => 'no-cache',
        ),
    );

    // Make the HTTP GET request using wp_remote_get
    $response = wp_remote_get($request_url, $request_args);

    // Check for errors
    if (is_wp_error($response)) {
        $html = array(
            'message' => 'false',
            'otpveification' => 'false',
            'messagetext' => '<div class="alert alert-danger" role="alert">Mobile number not in correct format or SMS API error</div>',
            'data' => $response->get_error_message(),
        );
    } else {
        // Decode the JSON response
        $mobiledataapi = json_decode(wp_remote_retrieve_body($response), true);

        // Check the 'return' key in the response
        if ($mobiledataapi['return'] != '1') {
            $html = array(
                'message' => 'false',
                'otpveification' => 'false',
                'messagetext' => '<div class="alert alert-danger" role="alert">Mobile number not in correct format or SMS API error</div>',
                'data' => $mobiledataapi,
            );
        } else {
            // Update the mobile resend OTP link
            $result = $database_helper->updatemobileresendotplink($otid, $FourDigitRandomNumber);

            // Response array
            $html = array(
                'message' => $result,
            );

            // Update the mobile resend link flag
            $database_helper->updatemobileresendLinkflag($otid);
        }
    }
}
else
{
    $html = array(
        'message' => 'false',
    ); 
}
            $response = new WP_REST_Response($html);
            return $response; 
    }

    public function mobileresendLinkshortcode():WP_REST_RESPONSE
    {
        if(isset($_POST['lid'])!=''){$lid=sanitize_text_field($_POST['lid']);} else {$lid='';}
        if(isset($_POST['otid'])!=''){$otid=sanitize_text_field($_POST['otid']);} else {$otid='';}
        if(isset($_POST['phone'])!=''){$phone=sanitize_text_field($_POST['phone']);} else {$phone='';}
        $database_helper = new DatabaseHelper();
        $resultcheck = $database_helper->checkmobileresendlinksend($otid,$phone);
        $result = $database_helper->checkmobileresendlinksendcheckonlyflag($otid);
// Check conditions
if ($resultcheck == 'true' && $result == 'false') {
    // Your DatabaseHelper class and other functions
    $database_helper = new DatabaseHelper();

    // Get API key from the database
    $result = $database_helper->getapiinfo();
    $apikey = $result[0]['apikey'];

    // Generate a random 6-digit number
    $FourDigitRandomNumber = mt_rand(111111, 999999);

    // Prepare the request parameters
    $request_url = "https://www.fast2sms.com/dev/bulkV2?f2s_ref=wp_lead_plugin&authorization=" . $apikey . "&variables_values=" . $FourDigitRandomNumber . "&route=otp&numbers=" . $phone;
    $request_args = array(
        'timeout' => 30,
        'sslverify' => false,
        'headers' => array(
            'cache-control' => 'no-cache',
        ),
    );

    // Make the HTTP GET request using wp_remote_get
    $response = wp_remote_get($request_url, $request_args);

    // Check for errors
    if (is_wp_error($response)) {
        $html = array(
            'message' => 'false',
            'otpveification' => 'false',
            'messagetext' => '<div class="alert alert-danger" role="alert">Mobile number not in correct format or SMS API error</div>',
            'data' => $response->get_error_message(),
        );
    } else {
        // Decode the JSON response
        $mobiledataapi = json_decode(wp_remote_retrieve_body($response), true);

        // Check the 'return' key in the response
        if ($mobiledataapi['return'] != '1') {
            $html = array(
                'message' => 'false',
                'otpveification' => 'false',
                'messagetext' => '<div class="alert alert-danger" role="alert">Mobile number not in correct format or SMS API error</div>',
                'data' => $mobiledataapi,
            );
        } else {
            // Update the mobile resend OTP link
            $result = $database_helper->updatemobileresendotplink($otid, $FourDigitRandomNumber);

            // Response array
            $html = array(
                'message' => $result,
            );

            // Update the mobile resend link flag
            $database_helper->updatemobileeresndtotplinkflag($otid);
        }
    }
}
 
else
{
    $html = array(
        'message' =>"false",
    ); 
}                          
        
            $response = new WP_REST_Response($html);
            return $response; 
    }
    public function insertleadshortcode(): WP_REST_RESPONSE
    {   

        if(isset($_POST['lid'])!=''){$lid=sanitize_text_field($_POST['lid']);} else {$lid='';}
        if(isset($_POST['fullnameshortcode'.$lid])!=''){$fullname=sanitize_text_field($_POST['fullnameshortcode'.$lid]);} else {$fullname='';}
      
        if(isset($_POST['emailshortcode'.$lid])!=''){$email=sanitize_text_field($_POST['emailshortcode'.$lid]);} else {$email='';}
        if(isset($_POST['phoneshort'.$lid])!=''){$phone=sanitize_text_field($_POST['phoneshort'.$lid]);} else {$phone='';}
        if(isset($_POST['verifymobnumbershortcode'.$lid])!=''){$verifymobnumber=sanitize_text_field($_POST['verifymobnumbershortcode'.$lid]);} else {$verifymobnumber='';}
        if(isset($_POST['countryCode'])!=''){$countryCode=sanitize_text_field($_POST['countryCode']);} else {$countryCode='';}
        if(isset($_POST['verifyemailshortcode'.$lid])!=''){$verifyemail=sanitize_text_field($_POST['verifyemailshortcode'.$lid]);} else {$verifyemail='';}
        
     
        $nonce = isset($_POST['tokenvalue'.$lid]) ? sanitize_text_field($_POST['tokenvalue'.$lid]) : '';
        $shortcode='[leadform lid="'.$lid.'"]';
        if(isset($_POST['extravalue'.$lid])!='')
        {
            $extravalue=sanitize_text_field($_POST['extravalue'.$lid]);
        }
        else
        {
            $extravalue='';
        }
        $tokenvalue = $extravalue;
        $database_helper = new DatabaseHelper();
        $resultchecktokencheck = $database_helper->checktokenvaluebeforeinsert($nonce);
       
       
        if (!wp_verify_nonce($nonce, $tokenvalue)) {
            // Nonce verification failed, handle the error
            //wp_send_json_error('Nonce verification failed.');
            $html = array(
                'message' => 'false',
                'otpveification' => 'false',
                'messagetext' => '<div class="alert alert-danger" role="alert">Token verification failed.</div>',
                'data' => '',
            );
        }
        if($resultchecktokencheck=='true')
        {
           
            $html = array(
                'message' => 'false',
                'otpveification' => 'false',
                'messagetext' => '<div class="alert alert-danger" role="alert">Token verification failed.</div>',
                'data' => '',
            );
        }
        else
        {
       
            $current_date_time = date('Y-m-d H:i:s');

                if(isset($_SERVER['HTTP_CF_CONNECTING_IP'])){
                    $_SERVER['REMOTE_ADDR']=$_SERVER['HTTP_CF_CONNECTING_IP'];
                }

                $user_ip = $_SERVER['REMOTE_ADDR'];
               
                /* Check if mobilenumber or email are exist in database or not code start*/
                $resultcheck = $database_helper->checkrecordexist($email,$phone,$verifyemail,$verifymobnumber);
                $ipaddresscounter = $database_helper->checkipaddresscounter($user_ip);//check IP address can not be more than 5
        
    
                    if($resultcheck=='true')
                    {
                    
                        $html = array(
                            'message' => $resultcheck,
                            'otpveification'=>'false',
                            'messagetext'=>'<div class="alert alert-danger" role="alert">Already registered</div>',
                            'data'=>'',
                        );

                    }
                
                    else if($ipaddresscounter<=5)
                    {
                      
                                $database_helper = new DatabaseHelper();
                            
                                    
                                    if($verifyemail=='yes' && $verifymobnumber=='')
                                    {
                                        $FourDigitRandomNumberemail = mt_rand(222222,888888);
                                   
                                            $subject='Email Verify OTP';
                                            $message='Email verify OTP is: '.$FourDigitRandomNumberemail.'';
                                          
                                            $email_template = '<table cellspacing="0" cellpadding="0" border="0" width="100%" bgcolor="#f4f4f4">
                                            <tr>
                                                <td align="center" style="padding: 20px;">
                                                    <table cellspacing="0" cellpadding="0" border="0" width="600" style="background-color: #ffffff; box-shadow: 0 4px 8px rgba(0, 0, 0, 0.2);">
                                                        <tr>
                                                            <td align="center" style="padding: 20px;">
                                                                <h1 style="color: #333;">Email Verify OTP</h1>
                                                                </td>
                                                        </tr>
                                                        <tr>
                                                            <td align="center" style="padding: 20px;">
                                                                <table cellspacing="0" cellpadding="0" border="0" width="100%">
                                                                   
                                                                    <tr>
                                                                      
                                                                        <td align="center" style="padding: 10px;">
                                                                        '.$message.'
                                                                        </td>
                                                                    </tr>
                                                                </table>
                                                            </td>
                                                        </tr>
                                                    </table>
                                                </td>
                                            </tr>
                                        </table>';
                                            $recipient_name = 'Fast2sms'; // Replace with the recipient's name
                                            $email_subject = $subject; // Replace with your email subject
                                            $headers = array(
                                                'Content-Type: text/html; charset=UTF-8',
                                            );
                                            $email_sent = wp_mail($email, $email_subject, $email_template, $headers);
                                            $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
                                            $characterSetLength = strlen($characters);
                                            $length=15;
                                            $uniqueRequestId = '';
                                            for ($i = 0; $i < $length; $i++) {
                                                $uniqueRequestId .= $characters[random_int(0, $characterSetLength - 1)];
                                            }

                                            

                                                $OTP_data_insert = array(
                                                    'countrycode'=>$countryCode,
                                                    'fullname'=>$fullname,
                                                    'email'=>$email,
                                                    'mobilenumber' => '',
                                                    'emailotpstatus'=>'no',
                                                    'mobileotpcode' => '',
                                                    'emailotpcode'=>$FourDigitRandomNumberemail,
                                                    'mobileotpstatus'=>'no',
                                                    'tokenvalue'=>$nonce,
                                                    'source'=> $shortcode,
                                                    'emailrequest_id' => $uniqueRequestId,
                                                    'mobilerequest_id' => '',
                                                    'ipaddress' => $user_ip,
                                                    'creationdate' => $current_date_time,
                                                    'updatedate'=>$current_date_time,
                                                );  
                                                $result = $database_helper->insertotpinfo($OTP_data_insert);
                                                $htmlrecord = array(
                                                    'fullname' => $fullname,
                                                    'email' => $email,
                                                    'emailrequest_id' => $uniqueRequestId,
                                                    'mobilerequest_id' => '',
                                                    'mobilenumberhtml' => $phone,
                                                    'countrycode'=>$countryCode,
                                                
                                                ); 
                                                $html = array(
                                                    'message' => $result['response'],
                                                    'otpveification'=>'true',
                                                    'mobile'=>'false',
                                                    'email'=>'true',
                                                    'messagetext'=>'',
                                                    'otid'=>$result['otid'],
                                                    'data'=>$htmlrecord,
                                                );
                        
                                       }
                                   
                                    if($verifyemail=='no' && $verifymobnumber=='')
                                    {
                                        $FourDigitRandomNumberemail="";
                                        $uniqueRequestId='';

                                        $OTP_data_insert = array(
                                            'countrycode'=>$countryCode,
                                            'fullname'=>$fullname,
                                            'email'=>$email,
                                            'mobilenumber' =>'',
                                            'emailotpstatus'=>'no',
                                            'mobileotpcode' => '',
                                            'emailotpcode'=>'',
                                            'mobileotpstatus'=>'no',
                                            'tokenvalue'=>$nonce,
                                            'source'=> $shortcode,
                                            'emailrequest_id' => $uniqueRequestId,
                                            'mobilerequest_id' => '',
                                            'ipaddress' => $user_ip,
                                            'creationdate' => $current_date_time,
                                            'updatedate'=>$current_date_time,
                                        );  
                                        $result = $database_helper->insertotpinfo($OTP_data_insert);
                                        $htmlrecord = array(
                                            'fullname' => $fullname,
                                            'email' => $email,
                                            'emailrequest_id' => '',
                                            'mobilerequest_id' => '',
                                            'mobilenumberhtml' => $phone,
                                            'countrycode'=>$countryCode,
                                        
                                        ); 
                                        $html = array(
                                            'message' => 'false',
                                            'otpveification'=>'false',
                                            'mobile'=>'false',
                                            'email'=>'false',
                                            'messagetext'=>'',
                                            'otid'=>$result['otid'],
                                            'data'=>$htmlrecord,
                                        );
                
                                         
                                    }
                                    if($verifymobnumber=='yes' && $verifyemail=='')
                                    {
                                        $result = $database_helper->getapiinfo();
                                          
                                        
                                        
                                                        $FourDigitRandomNumber = mt_rand(111111,999999);
                                                    if($countryCode=="+91")
                                                    {
                                                        // Check if $result is set and not empty
                                                    if (isset($result) && count($result) > 0) {
                                                        // Your DatabaseHelper class and other functions
                                                        $database_helper = new DatabaseHelper();

                                                        // Get API key from the database
                                                        $apikey = $result[0]['apikey'];

                                                        // Generate a random 6-digit number
                                                        $FourDigitRandomNumber = mt_rand(111111, 999999);

                                                        // Prepare the request parameters
                                                        $request_url = "https://www.fast2sms.com/dev/bulkV2?f2s_ref=wp_lead_plugin&authorization=" . $apikey . "&variables_values=" . $FourDigitRandomNumber . "&route=otp&numbers=" . $phone;
                                                        $request_args = array(
                                                            'timeout' => 30,
                                                            'sslverify' => false,
                                                            'headers' => array(
                                                                'cache-control' => 'no-cache',
                                                            ),
                                                        );

                                                        // Make the HTTP GET request using wp_remote_get
                                                        $response = wp_remote_get($request_url, $request_args);

                                                        // Check for errors
                                                        if (is_wp_error($response)) {
                                                            $html = array(
                                                                'message' => 'false',
                                                                'otpveification' => 'false',
                                                                'messagetext' => '<div class="alert alert-danger" role="alert">Mobile number not in correct format or SMS API error</div>',
                                                                'data' => $response->get_error_message(),
                                                            );
                                                        } else {
                                                            // Decode the JSON response
                                                            $mobiledataapi = json_decode(wp_remote_retrieve_body($response), true);

                                                            // Check the 'return' key in the response
                                                            if ($mobiledataapi['return'] != '1') {
                                                                $html = array(
                                                                    'message' => 'false',
                                                                    'otpveification' => 'false',
                                                                    'messagetext' => '<div class="alert alert-danger" role="alert">Mobile number not in correct format or SMS API error</div>',
                                                                    'data' => $mobiledataapi,
                                                                );
                                                            } else {
                                                                // Update the mobile resend OTP link
                                                                $result = $database_helper->insertotpinfo($OTP_data_insert);

                                                                // Your OTP data insert code
                                                                $OTP_data_insert = array(
                                                                    'countrycode' => $countryCode,
                                                                    'fullname' => $fullname,
                                                                    'email' => $email,
                                                                    'mobilenumber' => $phone,
                                                                    'emailotpstatus' => 'no',
                                                                    'mobileotpcode' => $FourDigitRandomNumber,
                                                                    'emailotpcode' => '',
                                                                    'mobileotpstatus' => 'no',
                                                                    'tokenvalue' => $nonce,
                                                                    'source' => $shortcode,
                                                                    'emailrequest_id' => '',
                                                                    'mobilerequest_id' => $mobiledataapi['request_id'],
                                                                    'ipaddress' => $user_ip,
                                                                    'creationdate' => $current_date_time,
                                                                    'updatedate' => $current_date_time,
                                                                );

                                                                // Your HTML record array
                                                                $htmlrecord = array(
                                                                    'fullname' => $fullname,
                                                                    'email' => $email,
                                                                    'emailrequest_id' => '',
                                                                    'mobilerequest_id' => $mobiledataapi['request_id'],
                                                                    'mobilenumberhtml' => $phone,
                                                                    'countrycode' => $countryCode,
                                                                );

                                                                // Response array
                                                                $html = array(
                                                                    'message' => $result['response'],
                                                                    'otpveification' => 'true',
                                                                    'mobile' => 'true',
                                                                    'email' => 'false',
                                                                    'messagetext' => '',
                                                                    'otid' => $result['otid'],
                                                                    'data' => $htmlrecord,
                                                                );
                                                            }
                                                        }
                                                    }

                                                      else
                                                      {
                                                        $html = array(
                                                            'message' => 'false',
                                                            'otpveification'=>'false',
                                                            'messagetext'=>'<div class="alert alert-danger" role="alert">API KEY IS NOT Exist</div>',
                                                            'data'=>''
                                                        ); 
                
                                                      }
                                                        
                                                    } //if country code is +91
                                                
                                                    else
                                                    {
                                                        $OTP_data_insert = array(
                                                            'countrycode'=>$countryCode,
                                                            'fullname'=>$fullname,
                                                            'email'=>$email,
                                                            'mobilenumber' => $phone,
                                                            'emailotpstatus'=>'no',
                                                            'mobileotpcode' => '',
                                                            'emailotpcode'=>'',
                                                            'mobileotpstatus'=>'no',
                                                            'tokenvalue'=>$nonce,
                                                            'source'=> $shortcode,
                                                            'emailrequest_id' =>'',
                                                            'mobilerequest_id' => '',
                                                            'ipaddress' => $user_ip,
                                                            'creationdate' => $current_date_time,
                                                            'updatedate'=>$current_date_time,
                                                        );  
                                                        $result = $database_helper->insertotpinfo($OTP_data_insert);
                                                        $htmlrecord = array(
                                                            'fullname' => $fullname,
                                                            'email' => $email,
                                                            'emailrequest_id' => '',
                                                            'mobilerequest_id' => '',
                                                            'mobilenumberhtml' => $phone,
                                                            'countrycode'=>$countryCode,
                                                        
                                                        ); 
                                                        $html = array(
                                                            'message' => 'false',
                                                            'otpveification'=>'false',
                                                            'mobile'=>'false',
                                                            'email'=>'false',
                                                            'messagetext'=>'',
                                                            'otid'=>$result['otid'],
                                                            'data'=>$htmlrecord,
                                                        );
                                
                                            
                                                    }//else if conuntry code is non indian
                                     
                                      }
                                      
                                  

                                    if($verifymobnumber=='no' && $verifyemail=='')

                                    {

                                            $OTP_data_insert = array(
                                                'countrycode'=>$countryCode,
                                                'fullname'=>$fullname,
                                                'email'=>$email,
                                                'mobilenumber' => $phone,
                                                'emailotpstatus'=>'no',
                                                'mobileotpcode' => '',
                                                'emailotpcode'=>'',
                                                'mobileotpstatus'=>'no',
                                                'tokenvalue'=>$nonce,
                                                'source'=> $shortcode,
                                                'emailrequest_id' =>'',
                                                'mobilerequest_id' => '',
                                                'ipaddress' => $user_ip,
                                                'creationdate' => $current_date_time,
                                                'updatedate'=>$current_date_time,
                                            );  
                                            $result = $database_helper->insertotpinfo($OTP_data_insert);
                                            $htmlrecord = array(
                                                'fullname' => $fullname,
                                                'email' => $email,
                                                'emailrequest_id' => '',
                                                'mobilerequest_id' => '',
                                                'mobilenumberhtml' => $phone,
                                                'countrycode'=>$countryCode,
                                            
                                            ); 
                                            $html = array(
                                                'message' => 'false',
                                                'otpveification'=>'false',
                                                'mobile'=>'false',
                                                'email'=>'false',
                                                'messagetext'=>'',
                                                'otid'=>$result['otid'],
                                                'data'=>$htmlrecord,
                                            );
                                    
                                    }

                                    //if both email and numbers are yes

                                    if($verifymobnumber=='yes' && $verifyemail=='yes')

                                    {
                                        $result = $database_helper->getapiinfo();
                                      
 
                                        $FourDigitRandomNumberemail = mt_rand(222222,888888);
                                   
                                            $subject='Email Verify OTP';
                                            $message='Email verify OTP is: '.$FourDigitRandomNumberemail.'';
                                          
                                            $email_template = '<table cellspacing="0" cellpadding="0" border="0" width="100%" bgcolor="#f4f4f4">
                                            <tr>
                                                <td align="center" style="padding: 20px;">
                                                    <table cellspacing="0" cellpadding="0" border="0" width="600" style="background-color: #ffffff; box-shadow: 0 4px 8px rgba(0, 0, 0, 0.2);">
                                                        <tr>
                                                            <td align="center" style="padding: 20px;">
                                                                <h1 style="color: #333;">Email Verify OTP</h1>
                                                                 </td>
                                                        </tr>
                                                        <tr>
                                                            <td align="center" style="padding: 20px;">
                                                                <table cellspacing="0" cellpadding="0" border="0" width="100%">
                                                                   
                                                                    <tr>
                                                                        
                                                                        <td align="center" style="padding: 10px;">
                                                                        '.$message.'
                                                                        </td>
                                                                    </tr>
                                                                </table>
                                                            </td>
                                                        </tr>
                                                    </table>
                                                </td>
                                            </tr>
                                        </table>';
                                            $recipient_name = 'Fast2sms'; // Replace with the recipient's name
                                            $email_subject = $subject; // Replace with your email subject
                                            $headers = array(
                                                'Content-Type: text/html; charset=UTF-8',
                                            );
                                            $email_sent = wp_mail($email, $email_subject, $email_template, $headers);
                                            $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
                                            $characterSetLength = strlen($characters);
                                            $length=15;
                                            $uniqueRequestId = '';
                                            for ($i = 0; $i < $length; $i++) {
                                                $uniqueRequestId .= $characters[random_int(0, $characterSetLength - 1)];
                                            }


                                            $FourDigitRandomNumber = mt_rand(111111,999999);
                                        if($countryCode == "+91") {
                                           // Check if $result is set and not empty
                                            if (isset($result) && count($result) > 0) {
                                                // Your DatabaseHelper class and other functions
                                                $database_helper = new DatabaseHelper();

                                                // Get API key from the database
                                                $apikey = $result[0]['apikey'];

                                                // Generate a random 6-digit number
                                                $FourDigitRandomNumber = mt_rand(111111, 999999);

                                                // Prepare the request parameters
                                                $request_url = "https://www.fast2sms.com/dev/bulkV2?f2s_ref=wp_lead_plugin&authorization=" . $apikey . "&variables_values=" . $FourDigitRandomNumber . "&route=otp&numbers=" . $phone;
                                                $request_args = array(
                                                    'timeout' => 30,
                                                    'sslverify' => false,
                                                    'headers' => array(
                                                        'cache-control' => 'no-cache',
                                                    ),
                                                );

                                                // Make the HTTP GET request using wp_remote_get
                                                $response = wp_remote_get($request_url, $request_args);

                                                // Check for errors
                                                if (is_wp_error($response)) {
                                                    $html = array(
                                                        'message' => 'false',
                                                        'otpveification' => 'false',
                                                        'messagetext' => '<div class="alert alert-danger" role="alert">Mobile number not in correct format or SMS API error</div>',
                                                        'data' => $response->get_error_message(),
                                                    );
                                                } else {
                                                    // Decode the JSON response
                                                    $mobiledataapi = json_decode(wp_remote_retrieve_body($response), true);

                                                    // Check the 'return' key in the response
                                                    if ($mobiledataapi['return'] != '1') {
                                                        $html = array(
                                                            'message' => 'false',
                                                            'otpveification' => 'false',
                                                            'messagetext' => '<div class="alert alert-danger" role="alert">Mobile number not in correct format or SMS API error</div>',
                                                            'data' => $mobiledataapi,
                                                        );
                                                    } else {
                                                        // Update the mobile resend OTP link
                                                        $result = $database_helper->insertotpinfo($OTP_data_insert);

                                                        // Your OTP data insert code
                                                        $OTP_data_insert = array(
                                                            'countrycode' => $countryCode,
                                                            'fullname' => $fullname,
                                                            'email' => $email,
                                                            'mobilenumber' => $phone,
                                                            'emailotpstatus' => 'no',
                                                            'mobileotpcode' => $FourDigitRandomNumber,
                                                            'emailotpcode' => $FourDigitRandomNumberemail,
                                                            'mobileotpstatus' => 'no',
                                                            'tokenvalue' => $nonce,
                                                            'source' => $shortcode,
                                                            'emailrequest_id' => $uniqueRequestId,
                                                            'mobilerequest_id' => $mobiledataapi['request_id'],
                                                            'ipaddress' => $user_ip,
                                                            'creationdate' => $current_date_time,
                                                            'updatedate' => $current_date_time,
                                                        );

                                                        // Your HTML record array
                                                        $htmlrecord = array(
                                                            'fullname' => $fullname,
                                                            'email' => $email,
                                                            'emailrequest_id' => $uniqueRequestId,
                                                            'mobilerequest_id' => $mobiledataapi['request_id'],
                                                            'mobilenumberhtml' => $phone,
                                                            'countrycode' => $countryCode,
                                                        );

                                                        // Response array
                                                        $html = array(
                                                            'message' => $result['response'],
                                                            'otpveification' => 'true',
                                                            'mobile' => 'true',
                                                            'email' => 'true',
                                                            'messagetext' => '',
                                                            'otid' => $result['otid'],
                                                            'data' => $htmlrecord,
                                                        );
                                                    }
                                                }
                                            }

                                            else {
                                                $html = array(
                                                    'message' => 'false',
                                                    'otpveification' => 'false',
                                                    'messagetext' => '<div class="alert alert-danger" role="alert">SMS API KEY not found</div>',
                                                    'data' => ''
                                                );
                                            }
                                        }
                                            else
                                            {
                                                $OTP_data_insert = array(
                                                    'countrycode'=>$countryCode,
                                                    'fullname'=>$fullname,
                                                    'email'=>$email,
                                                    'mobilenumber' => $phone,
                                                    'emailotpstatus'=>'no',
                                                    'mobileotpcode' => '',
                                                    'emailotpcode'=>$FourDigitRandomNumberemail,
                                                    'mobileotpstatus'=>'no',
                                                    'tokenvalue'=>$nonce,
                                                    'source'=> $shortcode,
                                                    'emailrequest_id' => $uniqueRequestId,
                                                    'mobilerequest_id' => '',
                                                    'ipaddress' => $user_ip,
                                                    'creationdate' => $current_date_time,
                                                    'updatedate'=>$current_date_time,
                                                );  
                                                $result = $database_helper->insertotpinfo($OTP_data_insert);
                                                $htmlrecord = array(
                                                    'fullname' => $fullname,
                                                    'email' => $email,
                                                    'emailrequest_id' => $uniqueRequestId,
                                                    'mobilerequest_id' => '',
                                                    'mobilenumberhtml' => $phone,
                                                    'countrycode'=>$countryCode,
                                                
                                                ); 
                                                $html = array(
                                                    'message' => $result['response'],
                                                    'otpveification'=>'true',
                                                    'mobile'=>'false',
                                                    'email'=>'true',
                                                    'messagetext'=>'',
                                                    'otid'=>$result['otid'],
                                                    'data'=>$htmlrecord,
                                                );
                        
                                 
                                        }//else if conuntry code is non indian

                                        }
                                      
                               
                                    if($verifymobnumber=='yes' && $verifyemail=='no')

                                    {

                                        
                                            $FourDigitRandomNumber = mt_rand(111111,999999);
                                            if($countryCode=="+91")
                                            {
                                                $result = $database_helper->getapiinfo();
                                                // Check if $result is set and not empty
                                                if (isset($result) && count($result) > 0) {
                                                    // Your DatabaseHelper class and other functions
                                                    $database_helper = new DatabaseHelper();

                                                    // Get API key from the database
                                                    $apikey = $result[0]['apikey'];

                                                    // Generate a random 6-digit number
                                                    $FourDigitRandomNumber = mt_rand(111111, 999999);

                                                    // Prepare the request parameters
                                                    $request_url = "https://www.fast2sms.com/dev/bulkV2?f2s_ref=wp_lead_plugin&authorization=" . $apikey . "&variables_values=" . $FourDigitRandomNumber . "&route=otp&numbers=" . $phone;
                                                    $request_args = array(
                                                        'timeout' => 30,
                                                        'sslverify' => false,
                                                        'headers' => array(
                                                            'cache-control' => 'no-cache',
                                                        ),
                                                    );

                                                    // Make the HTTP GET request using wp_remote_get
                                                    $response = wp_remote_get($request_url, $request_args);

                                                    // Check for errors
                                                    if (is_wp_error($response)) {
                                                        $html = array(
                                                            'message' => 'false',
                                                            'otpveification' => 'false',
                                                            'messagetext' => '<div class="alert alert-danger" role="alert">Mobile number not in correct format or SMS API error</div>',
                                                            'data' => $response->get_error_message(),
                                                        );
                                                    } else {
                                                        // Decode the JSON response
                                                        $mobiledataapi = json_decode(wp_remote_retrieve_body($response), true);

                                                        // Check the 'return' key in the response
                                                        if ($mobiledataapi['return'] != '1') {
                                                            $html = array(
                                                                'message' => 'false',
                                                                'otpveification' => 'false',
                                                                'messagetext' => '<div class="alert alert-danger" role="alert">Mobile number not in correct format or SMS API error</div>',
                                                                'data' => $mobiledataapi,
                                                            );
                                                        } else {
                                                            // Your OTP data insert code
                                                            $OTP_data_insert = array(
                                                                'countrycode' => $countryCode,
                                                                'fullname' => $fullname,
                                                                'email' => $email,
                                                                'mobilenumber' => $phone,
                                                                'emailotpstatus' => 'no',
                                                                'mobileotpcode' => $FourDigitRandomNumber,
                                                                'emailotpcode' => '',
                                                                'mobileotpstatus' => 'no',
                                                                'tokenvalue' => $nonce,
                                                                'source' => $shortcode,
                                                                'emailrequest_id' => '',
                                                                'mobilerequest_id' => $mobiledataapi['request_id'],
                                                                'ipaddress' => $user_ip,
                                                                'creationdate' => $current_date_time,
                                                                'updatedate' => $current_date_time,
                                                            );

                                                            // Your HTML record array
                                                            $htmlrecord = array(
                                                                'fullname' => $fullname,
                                                                'email' => $email,
                                                                'emailrequest_id' => '',
                                                                'mobilerequest_id' => $mobiledataapi['request_id'],
                                                                'mobilenumberhtml' => $phone,
                                                                'countrycode' => $countryCode,
                                                            );

                                                            // Insert OTP data and get the result
                                                            $result = $database_helper->insertotpinfo($OTP_data_insert);

                                                            // Response array
                                                            $html = array(
                                                                'message' => $result['response'],
                                                                'otpveification' => 'true',
                                                                'mobile' => 'true',
                                                                'email' => 'false',
                                                                'messagetext' => '',
                                                                'otid' => $result['otid'],
                                                                'data' => $htmlrecord,
                                                            );
                                                        }
                                                    }
                                                }

                                                else
                                                {
                                                    $html = array(
                                                        'message' => 'false',
                                                        'otpveification'=>'false',
                                                        'messagetext'=>'<div class="alert alert-danger" role="alert">API KEY IS NOT Exist</div>',
                                                        'data'=>''
                                                    ); 
            
                                                }
                                                
                                            } //if country code is +91
                                          
                                            else
                                            {
                                                $OTP_data_insert = array(
                                                    'countrycode'=>$countryCode,
                                                    'fullname'=>$fullname,
                                                    'email'=>$email,
                                                    'mobilenumber' => $phone,
                                                    'emailotpstatus'=>'no',
                                                    'mobileotpcode' => '',
                                                    'emailotpcode'=>'',
                                                    'mobileotpstatus'=>'no',
                                                    'tokenvalue'=>$nonce,
                                                    'source'=> $shortcode,
                                                    'emailrequest_id' => '',
                                                    'mobilerequest_id' => '',
                                                    'ipaddress' => $user_ip,
                                                    'creationdate' => $current_date_time,
                                                    'updatedate'=>$current_date_time,
                                                );  
                                                $result = $database_helper->insertotpinfo($OTP_data_insert);
                                                $htmlrecord = array(
                                                    'fullname' => $fullname,
                                                    'email' => $email,
                                                    'emailrequest_id' => '',
                                                    'mobilerequest_id' => '',
                                                    'mobilenumberhtml' => $phone,
                                                    'countrycode'=>$countryCode,
                                                
                                                ); 
                                                $html = array(
                                                    'message' => 'false',
                                                    'otpveification'=>'false',
                                                    'mobile'=>'false',
                                                    'email'=>'false',
                                                    'messagetext'=>'',
                                                    'otid'=>$result['otid'],
                                                    'data'=>$htmlrecord,
                                                );
                        
                                    }//else if conuntry code is non indian

                                            

                                    }//verifyemail yes and mobilenumber no




                                    if($verifymobnumber=='no' && $verifyemail=='yes')

                                    {

                                        $FourDigitRandomNumberemail = mt_rand(222222,888888);
                                   
                                            $subject='Email Verify OTP';
                                            $message='Email verify OTP is: '.$FourDigitRandomNumberemail.'';
                                          
                                            $email_template = '<table cellspacing="0" cellpadding="0" border="0" width="100%" bgcolor="#f4f4f4">
                                            <tr>
                                                <td align="center" style="padding: 20px;">
                                                    <table cellspacing="0" cellpadding="0" border="0" width="600" style="background-color: #ffffff; box-shadow: 0 4px 8px rgba(0, 0, 0, 0.2);">
                                                        <tr>
                                                            <td align="center" style="padding: 20px;">
                                                                <h1 style="color: #333;">Email Verify OTP</h1>
                                                                </td>
                                                        </tr>
                                                        <tr>
                                                            <td align="center" style="padding: 20px;">
                                                                <table cellspacing="0" cellpadding="0" border="0" width="100%">
                                                                   
                                                                    <tr>
                                                                       
                                                                        <td align="center" style="padding: 10px;">
                                                                        '.$message.'
                                                                        </td>
                                                                    </tr>
                                                                </table>
                                                            </td>
                                                        </tr>
                                                    </table>
                                                </td>
                                            </tr>
                                        </table>';
                                            $recipient_name = 'Fast2sms'; // Replace with the recipient's name
                                            $email_subject = $subject; // Replace with your email subject
                                            $headers = array(
                                                'Content-Type: text/html; charset=UTF-8',
                                            );
                                            $email_sent = wp_mail($email, $email_subject, $email_template, $headers);
                                            $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
                                            $characterSetLength = strlen($characters);
                                            $length=15;
                                            $uniqueRequestId = '';
                                            for ($i = 0; $i < $length; $i++) {
                                                $uniqueRequestId .= $characters[random_int(0, $characterSetLength - 1)];
                                            }


                                           
                                            
                                                $OTP_data_insert = array(
                                                    'countrycode'=>$countryCode,
                                                    'fullname'=>$fullname,
                                                    'email'=>$email,
                                                    'mobilenumber' => $phone,
                                                    'emailotpstatus'=>'no',
                                                    'mobileotpcode' => '',
                                                    'emailotpcode'=>$FourDigitRandomNumberemail,
                                                    'mobileotpstatus'=>'no',
                                                    'tokenvalue'=>$nonce,
                                                    'source'=> $shortcode,
                                                    'emailrequest_id' => $uniqueRequestId,
                                                    'mobilerequest_id' => '',
                                                    'ipaddress' => $user_ip,
                                                    'creationdate' => $current_date_time,
                                                    'updatedate'=>$current_date_time,
                                                );  
                                                $result = $database_helper->insertotpinfo($OTP_data_insert);
                                                $htmlrecord = array(
                                                    'fullname' => $fullname,
                                                    'email' => $email,
                                                    'emailrequest_id' => $uniqueRequestId,
                                                    'mobilerequest_id' => '',
                                                    'mobilenumberhtml' => $phone,
                                                    'countrycode'=>$countryCode,
                                                
                                                ); 
                                                $html = array(
                                                    'message' => $result['response'],
                                                    'otpveification'=>'true',
                                                    'mobile'=>'false',
                                                    'email'=>'true',
                                                    'messagetext'=>'',
                                                    'otid'=>$result['otid'],
                                                    'data'=>$htmlrecord,
                                                );
                        
                                 
                                    }//if mobile no and email yes

                                    if($verifymobnumber=='no' && $verifyemail=='no')

                                    {

                                            $OTP_data_insert = array(
                                                'countrycode'=>$countryCode,
                                                'fullname'=>$fullname,
                                                'email'=>$email,
                                                'mobilenumber' => $phone,
                                                'emailotpstatus'=>'no',
                                                'mobileotpcode' => '',
                                                'emailotpcode'=>'',
                                                'mobileotpstatus'=>'no',
                                                'tokenvalue'=>$nonce,
                                                'source'=> $shortcode,
                                                'emailrequest_id' => '',
                                                'mobilerequest_id' => '',
                                                'ipaddress' => $user_ip,
                                                'creationdate' => $current_date_time,
                                                'updatedate'=>$current_date_time,
                                            );  
                                            $result = $database_helper->insertotpinfo($OTP_data_insert);
                                            $htmlrecord = array(
                                                'fullname' => $fullname,
                                                'email' => $email,
                                                'emailrequest_id' => '',
                                                'mobilerequest_id' => '',
                                                'mobilenumberhtml' => $phone,
                                                'countrycode'=>$countryCode,
                                            
                                            ); 
                                            $html = array(
                                                'message' => 'false',
                                                'otpveification'=>'false',
                                                'mobile'=>'false',
                                                'email'=>'false',
                                                'messagetext'=>'',
                                                'otid'=>$result['otid'],
                                                'data'=>$htmlrecord,
                                            );
                                  }
                           


                     
                    }//to many if conidtion end
                    else
                    {
                        //echo "counter:". $ipaddresscounter;
                    
                        $html = array(
                            'message' => 'false',
                            'otpveification'=>'false',
                            'messagetext'=>'<div class="alert alert-danger" role="alert">Too many request</div>',
                            'data'=>''
                        ); 
                            
                    } //too many else condition end
            
                  
              
        }
        $response = new WP_REST_Response($html);
        return $response;
    }
    public function otpverification(): WP_REST_Response
    {
        $phone=sanitize_text_field($_POST['phonenumberotp']);
        $email=sanitize_text_field($_POST['emailotp']);
        $verificationcode=sanitize_text_field($_POST['verificationcode']);
        $emailverificationcode=sanitize_text_field($_POST['emailverificationcode']);
        $mobilerequestid=sanitize_text_field($_POST['mobilerequestid']);
        $emailrequestid=sanitize_text_field($_POST['emailrequestid']);
        $database_helper = new DatabaseHelper();
        /*Update status of otp*/
       
        /*update status of otp end*/
        $mobilerecord  = $database_helper->checkmobileotpverification($phone,$verificationcode,$mobilerequestid);
        $emailrecord  = $database_helper->checkemailotpverification($email,$emailverificationcode,$emailrequestid);
        //echo "Mobilerecord:".$mobilerecord."<br>";
        //echo "emailrecord:".$emailrecord."<br>";
        if($verificationcode!='' && $emailverificationcode!='')
        {
            
            if($emailrecord=='true')
            {
            $dataemail = array(
                'emailotpstatus' => 'yes',
            ); 
            $database_helper->updateemailotpstatus($email,$emailverificationcode,$emailrequestid,$dataemail); 
            }
           if($mobilerecord=='true')
            {
            $datamobile = array(
                'mobileotpstatus' => 'yes',
            ); 
            $database_helper->updatemobieotpstatus($phone,$verificationcode,$mobilerequestid,$datamobile);
            }
            if($emailrecord=='true' && $mobilerecord=='true')
            {
            $html = array(
                'message' => "true",
            );
          }
          else
          {
            $html = array(
                'message' => "false",
            );
          }

        }
        else if($verificationcode!='' && $emailverificationcode=='')
        {
            if($mobilerecord=='true')
            {
            $datamobile = array(
                'mobileotpstatus' => 'yes',
            ); 
            $database_helper->updatemobieotpstatus($phone,$verificationcode,$mobilerequestid,$datamobile);
            $html = array(
                'message' => "true",
            );
            }
            else
            {
                $html = array(
                    'message' => "false",
                );
            }
        
           
        }
        else if($verificationcode=='' && $emailverificationcode!='')
        {
            
           
            if($emailrecord=='true')
            {
            $dataemail = array(
                'emailotpstatus' => 'yes',
            ); 
            $database_helper->updateemailotpstatus($email,$emailverificationcode,$emailrequestid,$dataemail); 
            $html = array(
                'message' => "true",
            );
            }
            else
            {
                $html = array(
                    'message' => "false",
                ); 
            }
           
        }
        else
        {
            $html = array(
                'message' => "false",
            );
        }   
        
            
      
        $response = new WP_REST_Response($html);
        return $response;
    }
    public function otpshortcodeverification(): WP_REST_Response
    {   
        $lid=sanitize_text_field($_POST['lid']);
        $otid =sanitize_text_field($_POST['otid'.$lid]);
        $phone=sanitize_text_field($_POST['phonenumberotpshortcode'.$lid]);
        $email=sanitize_text_field($_POST['emailotpshortcode'.$lid]);
        $verificationcode=sanitize_text_field($_POST['verificationshortcode'.$lid]);
        $emailverificationcode=sanitize_text_field($_POST['emailverificationshortcode'.$lid]);
        $mobilerequestid=sanitize_text_field($_POST['mobilerequestidshortcode'.$lid]);
        $emailrequestid=sanitize_text_field($_POST['emailrequestidshortcode'.$lid]);
        $database_helper = new DatabaseHelper();
        /*Update status of otp*/
     
        /*update status of otp end*/
       
  
        $mobilerecord  = $database_helper->checkmobileotpverification($phone,$verificationcode,$mobilerequestid);
        $emailrecord  = $database_helper->checkemailotpverification($email,$emailverificationcode,$emailrequestid);
        //echo "Mobilerecord:".$mobilerecord."<br>";
        //echo "emailrecord:".$emailrecord."<br>";
        if($verificationcode!='' && $emailverificationcode!='')
        {
            
            if($emailrecord=='true')
            {
            $dataemail = array(
                'emailotpstatus' => 'yes',
            ); 
            $database_helper->updateemailotpstatus($email,$emailverificationcode,$emailrequestid,$dataemail); 
            }
           if($mobilerecord=='true')
            {
            $datamobile = array(
                'mobileotpstatus' => 'yes',
            ); 
            $database_helper->updatemobieotpstatus($phone,$verificationcode,$mobilerequestid,$datamobile);
            }
            if($emailrecord=='true' && $mobilerecord=='true')
            {
            $html = array(
                'message' => "true",
            );
          }
          else
          {
            $html = array(
                'message' => "false",
            );
          }

        }
        else if($verificationcode!='' && $emailverificationcode=='')
        {
            if($mobilerecord=='true')
            {
            $datamobile = array(
                'mobileotpstatus' => 'yes',
            ); 
            $database_helper->updatemobieotpstatus($phone,$verificationcode,$mobilerequestid,$datamobile);
            $html = array(
                'message' => "true",
            );
            }
            else
            {
                $html = array(
                    'message' => "false",
                );
            }
        
           
        }
        else if($verificationcode=='' && $emailverificationcode!='')
        {
            
           
            if($emailrecord=='true')
            {
            $dataemail = array(
                'emailotpstatus' => 'yes',
            ); 
            $database_helper->updateemailotpstatus($email,$emailverificationcode,$emailrequestid,$dataemail); 
            $html = array(
                'message' => "true",
            );
            }
            else
            {
                $html = array(
                    'message' => "false",
                ); 
            }
           
        }
        else
        {
            $html = array(
                'message' => "false",
            );
        }   
        
         
     
     $response = new WP_REST_Response($html);
        return $response;
    }
    public function collected_data() {
        $database_helper = new DatabaseHelper();
        $result = $database_helper->getcollecteddata();
        $data = array(
            'records' => $result,
        );
        include "view/collecteddata.php";
    }
    
    
    public function enqueue_plugin_assets() {
        wp_register_style('fast2sms',  (plugin_dir_url(__FILE__) .'/assets/css/back-end.css'), false, '1.1.2', 'all');
        wp_enqueue_style('fast2sms');
        wp_enqueue_style('bootstrap-min', (plugin_dir_url(__FILE__) .'/assets/bootstrap/css/bootstrap.min.css'), false, '5.2.3', 'all');
        
        wp_enqueue_style('bootstrap-min-datatable', (plugin_dir_url(__FILE__) .'/assets/css/dataTables.bootstrap5.min.css'), false, '1.13.6', 'all');
        wp_enqueue_style('font-awesome', (plugin_dir_url(__FILE__) .'/assets/css/fonts-all-min.css'), false, '6.4.2', 'all');
        wp_enqueue_script('bootstrap-bundle', (plugin_dir_url(__FILE__) .'/assets/bootstrap/js/bootstrap.bundle.min.js'), array('jquery'), '5.2.3', false);
        //wp_enqueue_script('jquery-3.7', 'https://code.jquery.com/jquery-3.7.0.js', array('jquery'), '3.7', false);
        wp_enqueue_script('jquery-validation', (plugin_dir_url(__FILE__) .'/assets/js/jquery.validate.min.js'), array('jquery'), '1.19.3', false);
        wp_enqueue_script('jquery-datatable', (plugin_dir_url(__FILE__) .'/assets/js/jquery.dataTables.min.js'), array('jquery'), '1.13.6', false);
     }
     public function enqueue_modal_scripts() {
        wp_enqueue_style('modal-style', plugin_dir_url(__FILE__) . 'assets/css/front-end.css', array(), '1.1.3');
        wp_enqueue_style('fonts-style', plugin_dir_url(__FILE__) . 'assets/css/fonts.css', array(), '1.1');
        wp_enqueue_style('intlTelInput', plugin_dir_url(__FILE__) . 'assets/css/intlTelInput.css', array(), '17.0.11');

        $database_helper = new DatabaseHelper();
        $result = $database_helper->getfrontendpopup();
         
        $tokenLength = 32;
        $randomBytes = random_bytes($tokenLength);
        $tokenValue = bin2hex($randomBytes);
        $nonce=wp_create_nonce($tokenValue);
        if(isset($result[0]['loadtime']))
        {
            $loadtime=$result[0]['loadtime'];
        }
        else
        {
            $loadtime="";
        }
        $general_settings_url = get_option('siteurl');
        $custom_data = array(
            'loadtime' => $loadtime,
            'nonce'=>$nonce,
            'tnv'=>$tokenValue,
            'currenturl'=>$general_settings_url,
        );
        if(isset($result[0]['popuploadoption']) && $result[0]['popuploadoption']==3)

         {
            
            if (is_front_page()) {
            wp_enqueue_script('modal-script', plugin_dir_url(__FILE__) . 'assets/js/modal-script.js', array('jquery'), '1.1.2', false);
            wp_localize_script('modal-script', 'customData', $custom_data);
            }
          
        }
        if(isset($result[0]['popuploadoption']) && $result[0]['popuploadoption']==1 || isset($result[0]['popuploadoption']) &&  $result[0]['popuploadoption']==2 || isset($result[0]['popuploadoption']) &&  $result[0]['popuploadoption']==4)
        {
            wp_enqueue_script('modal-script', plugin_dir_url(__FILE__) . 'assets/js/modal-script.js', array('jquery'), '1.1.2', false);
            wp_localize_script('modal-script', 'customData', $custom_data);

        }
        wp_enqueue_script('intlTelInput-script', 'https://cdnjs.cloudflare.com/ajax/libs/intl-tel-input/17.0.8/js/intlTelInput.min.js', array('jquery'), '17.0.8');
        
        wp_enqueue_script('jquery-validation', (plugin_dir_url(__FILE__) .'/assets/js/jquery.validate.min.js'), array('jquery'), '1.19.3', false);
    }
  public function getCountryNameByDialCode($dialCode) {

    $dialCodeToCountry = array( '+93' => 'Afghanistan', '+355' => 'Albania', '+213' => 'Algeria', '+376' => 'Andorra', '+244' => 'Angola', '+54' => 'Argentina', '+374' => 'Armenia', '+297' => 'Aruba', '+61' => 'Australia', '+43' => 'Austria', '+994' => 'Azerbaijan', '+973' => 'Bahrain', '+880' => 'Bangladesh', '+375' => 'Belarus', '+32' => 'Belgium', '+501' => 'Belize', '+229' => 'Benin', '+975' => 'Bhutan', '+591' => 'Bolivia', '+387' => 'Bosnia and Herzegovina', '+267' => 'Botswana', '+55' => 'Brazil', '+673' => 'Brunei', '+359' => 'Bulgaria', '+226' => 'Burkina Faso', '+257' => 'Burundi', '+855' => 'Cambodia', '+237' => 'Cameroon', '+238' => 'Cape Verde', '+236' => 'Central African Republic', '+235' => 'Chad', '+56' => 'Chile', '+86' => 'China', '+57' => 'Colombia', '+269' => 'Comoros', '+243' => 'Congo (Kinshasa)', '+242' => 'Congo (Brazzaville)', '+506' => 'Costa Rica', '+385' => 'Croatia', '+53' => 'Cuba', '+599' => 'Curacao', '+357' => 'Cyprus', '+420' => 'Czech Republic', '+45' => 'Denmark', '+253' => 'Djibouti','+593' => 'Ecuador', '+20' => 'Egypt', '+503' => 'El Salvador', '+240' => 'Equatorial Guinea', '+291' => 'Eritrea', '+372' => 'Estonia', '+251' => 'Ethiopia', '+679' => 'Fiji', '+358' => 'Finland', '+33' => 'France', '+241' => 'Gabon', '+220' => 'Gambia', '+995' => 'Georgia', '+49' => 'Germany', '+233' => 'Ghana', '+350' => 'Gibraltar', '+30' => 'Greece','+502' => 'Guatemala', '+224' => 'Guinea', '+245' => 'Guinea-Bissau', '+592' => 'Guyana', '+509' => 'Haiti', '+504' => 'Honduras', '+852' => 'Hong Kong', '+36' => 'Hungary', '+354' => 'Iceland', '+91' => 'India', '+62' => 'Indonesia', '+98' => 'Iran', '+964' => 'Iraq', '+353' => 'Ireland', '+972' => 'Israel', '+39' => 'Italy', '+81' => 'Japan', '+962' => 'Jordan', '+7' => 'Kazakhstan', '+254' => 'Kenya', '+686' => 'Kiribati', '+850' => 'North Korea', '+82' => 'South Korea', '+383' => 'Kosovo', '+965' => 'Kuwait', '+996' => 'Kyrgyzstan', '+856' => 'Laos', '+371' => 'Latvia', '+961' => 'Lebanon', '+266' => 'Lesotho', '+231' => 'Liberia', '+218' => 'Libya', '+423' => 'Liechtenstein', '+370' => 'Lithuania', '+352' => 'Luxembourg', '+853' => 'Macau', '+389' => 'North Macedonia', '+261' => 'Madagascar', '+265' => 'Malawi', '+60' => 'Malaysia', '+960' => 'Maldives', '+223' => 'Mali', '+356' => 'Malta', '+692' => 'Marshall Islands', '+222' => 'Mauritania', '+230' => 'Mauritius', '+52' => 'Mexico', '+691' => 'Micronesia', '+373' => 'Moldova', '+377' => 'Monaco', '+976' => 'Mongolia', '+382' => 'Montenegro', '+212' => 'Morocco', '+258' => 'Mozambique', '+95' => 'Myanmar (Burma)', '+264' => 'Namibia', '+674' => 'Nauru', '+977' => 'Nepal', '+31' => 'Netherlands', '+687' => 'New Caledonia', '+64' => 'New Zealand', '+505' => 'Nicaragua', '+227' => 'Niger', '+234' => 'Nigeria', '+850' => 'Niue', '+47' => 'Norway', '+968' => 'Oman', '+92' => 'Pakistan', '+680' => 'Palau', '+970' => 'Palestine', '+507' => 'Panama', '+675' => 'Papua New Guinea', '+595' => 'Paraguay', '+51' => 'Peru', '+63' => 'Philippines', '+48' => 'Poland', '+351' => 'Portugal', '+974' => 'Qatar', '+262' => 'Reunion', '+40' => 'Romania', '+7' => 'Russia', '+250' => 'Rwanda','+685' => 'Samoa', '+378' => 'San Marino', '+239' => 'Sao Tome and Principe', '+966' => 'Saudi Arabia', '+221' => 'Senegal', '+381' => 'Serbia', '+248' => 'Seychelles', '+232' => 'Sierra Leone', '+65' => 'Singapore', '+421' => 'Slovakia', '+386' => 'Slovenia', '+677' => 'Solomon Islands', '+252' => 'Somalia', '+27' => 'South Africa', '+211' => 'South Sudan', '+34' => 'Spain', '+94' => 'Sri Lanka', '+249' => 'Sudan', '+597' => 'Suriname', '+268' => 'Eswatini', '+46' => 'Sweden', '+41' => 'Switzerland', '+963' => 'Syria', '+886' => 'Taiwan', '+992' => 'Tajikistan', '+255' => 'Tanzania', '+66' => 'Thailand', '+670' => 'Timor-Leste', '+228' => 'Togo', '+676' => 'Tonga','+216' => 'Tunisia', '+90' => 'Turkey', '+993' => 'Turkmenistan', '+688' => 'Tuvalu', '+256' => 'Uganda', '+380' => 'Ukraine', '+971' => 'United Arab Emirates', '+44' => 'United Kingdom', '+1' => 'United States', '+598' => 'Uruguay', '+998' => 'Uzbekistan', '+678' => 'Vanuatu', '+39' => 'Vatican City', '+58' => 'Venezuela', '+84' => 'Vietnam', '+681' => 'Wallis and Futuna', '+967' => 'Yemen', '+260' => 'Zambia', '+263' => 'Zimbabwe', );
    if (isset($dialCodeToCountry[$dialCode])) {
        return $dialCodeToCountry[$dialCode];
    } else {
        return 'Unknown'; // Return 'Unknown' for unrecognized dial codes
    }
}    
    public function exportdata(): WP_REST_Response
     {
        $database_helper = new DatabaseHelper();
       
        $selectedData = sanitize_text_field($_POST['selected_data']);
        if($selectedData!='')
        {
            $selectedRows = array();
            foreach ($selectedData as $selectedID) {
                // Assuming you have a function to retrieve data from the database
                $rowData = $database_helper->getexportselecteddata($selectedID);
                if ($rowData) {
                    $selectedRows[] = $rowData;
                }
            }
        
            $data = array(
                array('Name','Email','Email Verified','Mobile','Mobile Verified','Country','Ip Address','Source','Date & time'),
            );
        
            // Convert the data to a CSV format
            $csv_data = '';
            foreach ($data as $row) {
                $csv_data .= implode(',', $row) . "\r\n";
            }
            //print_r($results);
            $countryHelper = new Fast2SmsPlugin();
            foreach ($selectedRows as $record) {
                if($record['mobileotpstatus'] != '0') {
                    $mobileotpstatus = "Yes";
                } else {
                    $mobileotpstatus = "No";
                }
                if($record['emailotpstatus'] != '0') {
                    $emailotpstatus = "Yes";
                } else {
                    $emailotpstatus = "No";
                }
                $csv_data .= implode(',', array($record['fullname'], $record['email'],$emailotpstatus,$record['mobilenumber'],$mobileotpstatus,$countryHelper->getCountryNameByDialCode("+" . $record['countrycode']),$record['ipaddress'],$record['source'],$record['creationdate'])) . "\r\n";
                //$csv_data .= implode(',', $record) . "\r\n";
            }
        
            // Return the CSV data in the response
            $html = array(
                'success' => true,
                'data' => $csv_data,
            );
            $response = new WP_REST_Response($html);
            return $response;
        }
        else
        {
            $results = $database_helper->exportdata();
            $data = array(
                array('Name','Email','Email Verified','Mobile','Mobile Verified','Country','Ip Address','Source','Date & time'),
            );
    // Convert the data to a CSV format
    $csv_data = '';
    foreach ($data as $row) {
        $csv_data .= implode(',', $row) . "\r\n";
    }
    //print_r($results);
    $countryHelper = new Fast2SmsPlugin();
    foreach ($results as $record) {
        if($record['mobileotpstatus'] != '0') {
            $mobileotpstatus = "Yes";
        } else {
            $mobileotpstatus = "No";
        }
        if($record['emailotpstatus'] != '0') {
            $emailotpstatus = "Yes";
        } else {
            $emailotpstatus = "No";
        }
        $csv_data .= implode(',', array($record['fullname'], $record['email'],$emailotpstatus,$record['mobilenumber'],$mobileotpstatus,$countryHelper->getCountryNameByDialCode("+" . $record['countrycode']),$record['ipaddress'],$record['source'],$record['creationdate'])) . "\r\n";

        //$csv_data .= implode(',', $record) . "\r\n";
    }

    // Return the CSV data in the response
    $html = array(
        'success' => true,
        'data' => $csv_data,
    );
    $response = new WP_REST_Response($html);
    return $response;
}

    }

    public function deleterecord()
    {
        $database_helper = new DatabaseHelper();
       
        $selectedData = $_POST['selected_data'];
        $selectedRows = array();
        foreach ($selectedData as $selectedID) {
            // Assuming you have a function to retrieve data from the database
            $rowData = $database_helper->deleterecords($selectedID);
            if ($rowData) {
                $selectedRows[] = $rowData;
            }
        }
        $countArray = array();

        // Count occurrences based on a specific field in the records
        foreach ($selectedRows as $row) {
            // Assuming you want to count based on some field in the $row array
            $countField = $row['message']; // Replace 'countField' with your actual field name
        
            if (isset($countArray[$countField])) {
                $countArray[$countField]++;
            } else {
                $countArray[$countField] = 1;
            }
        }
       
        $countString = '';
        foreach ($countArray as $field => $count) {
            $countString .= "$count\n";
        }
        // Return the CSV data in the response
        $html = array(
            'success' => true,
            'message'=>'<div class="alert alert-danger" role="alert">You have deleted '.$countString.' Records.<a onClick="window.location.reload()" style="color:blue;">Please referesh page to view</a></div>',
        );
        $response = new WP_REST_Response($html);
        return $response;
    }
    public function makeprimarywidget(): WP_REST_Response
     {
        $database_helper = new DatabaseHelper();
        $fid=sanitize_text_field($_POST['fid']);
        $primarywidget="true";
        $data_to_update = array(
            'primarywidget' => $primarywidget,
        );  
        $result = $database_helper->makeprimarywidget($data_to_update,$fid);
        $response = new WP_REST_Response($result);
        return $response;
     }

     public function leadform_shortcode($atts) {
        $tokenLength = 32;
        $randomBytes = random_bytes($tokenLength);
        $tokenValue = bin2hex($randomBytes);
        $nonce=wp_create_nonce($tokenValue);

        $atts = shortcode_atts(array(
            'lid' => '1', // Default value for 'lid' if not specified in the shortcode
        ), $atts);
        
        // Your code to process the shortcode goes here
        $lid = esc_attr($atts['lid']);
        $database_helper = new DatabaseHelper();
        $result = $database_helper->getfast2smsshortcode($lid);
        
        
       if(isset($result) && $result['leadstatus']=='1')
       {
       
        $data = array(
            'records' => $result,
            'tnv'=>$tokenValue,
            'nonce'=>$nonce
        );
        ob_start();
        include "view/displayfast2smsshortcode.php";
        
        $output = ob_get_clean();
         }
         else
         {
            $output="<h5>Shortcode not found or disabled</h5>";
         }
        return $output;
    }
    public function contact_us()
    {
        
        include "view/contactus.php";
    }
   public function contactusemailsend():WP_REST_RESPONSE
   {
    $name=sanitize_text_field($_POST['name']);
    $email=sanitize_text_field($_POST['email']);
    $subject=sanitize_text_field($_POST['subject']);
    $message=sanitize_text_field($_POST['message']);
  
    $email_template = '<table cellspacing="0" cellpadding="0" border="0" width="100%" bgcolor="#f4f4f4">
    <tr>
        <td align="center" style="padding: 20px;">
            <table cellspacing="0" cellpadding="0" border="0" width="600" style="background-color: #ffffff; box-shadow: 0 4px 8px rgba(0, 0, 0, 0.2);">
                <tr>
                    <td align="center" style="padding: 20px;">
                        <h1 style="color: #333;">Contact Us</h1>
                        <p style="color: #666; line-height: 1.6;">Thank you for reaching out to us. </td>
                </tr>
                <tr>
                    <td align="center" style="padding: 20px;">
                        <table cellspacing="0" cellpadding="0" border="0" width="100%">
                            <tr>
                                <td align="left" style="padding: 10px;">
                                    <label for="name" style="font-weight: bold;">Name:</label>
                                </td>
                                <td align="left" style="padding: 10px;">
                                 '.$name.'
                                </td>
                            </tr>
                            <tr>
                                <td align="left" style="padding: 10px;">
                                    <label for="email" style="font-weight: bold;">Email:</label>
                                </td>
                                <td align="left" style="padding: 10px;">
                                '.$email.'
                                </td>
                            </tr>
                            <tr>
                                <td align="left" style="padding: 10px;">
                                    <label for="name" style="font-weight: bold;">Subject:</label>
                                </td>
                                <td align="left" style="padding: 10px;">
                                 '.$subject.'
                                </td>
                            </tr>
                            <tr>
                                <td align="left" style="padding: 10px;">
                                    <label for="message" style="font-weight: bold;">Message:</label>
                                </td>
                                <td align="left" style="padding: 10px;">
                                '.$message.'
                                </td>
                            </tr>
                        </table>
                    </td>
                </tr>
            </table>
        </td>
    </tr>
</table>';


    $recipient_name = 'Fast2sms'; // Replace with the recipient's name
    $email_subject = 'Contact Us Fast2sms Plugin'; // Replace with your email subject
    $email_template = str_replace('[Name]', $recipient_name, $email_template);

    // Email headers
    $headers = array(
        'Content-Type: text/html; charset=UTF-8',
    );

    // Send the email
    $email_sent = wp_mail('chaudharyrakeshit@gmail.com', $email_subject, $email_template, $headers);

    if ($email_sent) {
       $result="true";
    } else {
      $result="false";
    }
    $response = new WP_REST_Response($result);
    return $response;
   }
}
new Fast2SmsPlugin();
?>